/* THIS FILE IS AUTOGENERATED FROM AudioData.webidl BY Codegen.py - DO NOT EDIT */

#ifndef DOM_AUDIODATABINDING_H_
#define DOM_AUDIODATABINDING_H_

#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/EnumTypeTraits.h"
#include "mozilla/Span.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"
#include "mozilla/dom/TypedArray.h"
#include "mozilla/dom/UnionTypes.h"

namespace mozilla {
namespace dom {

class AudioData;
struct AudioDataCopyToOptionsAtoms;
struct AudioDataInitAtoms;
class MaybeSharedArrayBufferViewOrMaybeSharedArrayBuffer;
struct NativePropertyHooks;
class OwningMaybeSharedArrayBufferViewOrMaybeSharedArrayBuffer;
class ProtoAndIfaceCache;

} // namespace dom
} // namespace mozilla

namespace mozilla {

namespace dom {

enum class AudioSampleFormat : uint8_t {
  U8,
  S16,
  S32,
  F32,
  U8_planar,
  S16_planar,
  S32_planar,
  F32_planar,
};

namespace binding_detail {
template <> struct EnumStrings<AudioSampleFormat> {
  static constexpr nsLiteralCString Values[8] {
    "u8"_ns,
    "s16"_ns,
    "s32"_ns,
    "f32"_ns,
    "u8-planar"_ns,
    "s16-planar"_ns,
    "s32-planar"_ns,
    "f32-planar"_ns,
  };
};
} // namespace binding_detail

bool
ToJSValue(JSContext* aCx, AudioSampleFormat aArgument, JS::MutableHandle<JS::Value> aValue);


struct AudioDataCopyToOptions : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Optional<AudioSampleFormat> mFormat;
  MOZ_INIT_OUTSIDE_CTOR Optional<uint32_t> mFrameCount;
  MOZ_INIT_OUTSIDE_CTOR uint32_t mFrameOffset;
  MOZ_INIT_OUTSIDE_CTOR uint32_t mPlaneIndex;

  AudioDataCopyToOptions();

  explicit inline AudioDataCopyToOptions(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  AudioDataCopyToOptions(AudioDataCopyToOptions&& aOther) = default;

  explicit inline AudioDataCopyToOptions(const AudioDataCopyToOptions& aOther)
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  AudioDataCopyToOptions&
  operator=(const AudioDataCopyToOptions& aOther);

private:
  static bool
  InitIds(JSContext* cx, AudioDataCopyToOptionsAtoms* atomsCache);
};

namespace binding_detail {
struct FastAudioDataCopyToOptions : public AudioDataCopyToOptions
{
  inline FastAudioDataCopyToOptions()
    : AudioDataCopyToOptions(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct AudioDataInit : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR OwningMaybeSharedArrayBufferViewOrMaybeSharedArrayBuffer mData;
  MOZ_INIT_OUTSIDE_CTOR AudioSampleFormat mFormat;
  MOZ_INIT_OUTSIDE_CTOR uint32_t mNumberOfChannels;
  MOZ_INIT_OUTSIDE_CTOR uint32_t mNumberOfFrames;
  MOZ_INIT_OUTSIDE_CTOR float mSampleRate;
  MOZ_INIT_OUTSIDE_CTOR int64_t mTimestamp;
  MOZ_INIT_OUTSIDE_CTOR Sequence<ArrayBuffer> mTransfer;

  AudioDataInit();

  explicit inline AudioDataInit(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  AudioDataInit(AudioDataInit&& aOther) = default;

private:
  AudioDataInit(const AudioDataInit&) = delete;
  AudioDataInit& operator=(const AudioDataInit&) = delete;

  static bool
  InitIds(JSContext* cx, AudioDataInitAtoms* atomsCache);

public:
  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);
};

namespace binding_detail {
struct FastAudioDataInit : public AudioDataInit
{
  inline FastAudioDataInit()
    : AudioDataInit(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace AudioData_Binding {

  typedef mozilla::dom::AudioData NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  bool
  Wrap(JSContext* aCx, mozilla::dom::AudioData* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, DefineInterfaceProperty aDefineOnGlobal);

  JS::Handle<JSObject*>
  GetConstructorObjectHandle(JSContext* aCx);

  inline bool CreateAndDefineOnGlobal(JSContext* aCx)
  {
    // Get the interface or namespace object for this class. This will
    // create the object as needed and always define the properties for
    // it on the global. The caller should make sure the interface or
    // namespace is exposed on the global before calling this.
    return GetPerInterfaceObjectHandle(aCx, constructors::id::AudioData,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::Always);

  }

} // namespace AudioData_Binding



} // namespace dom


template <>
struct MaxContiguousEnumValue<dom::AudioSampleFormat>
{
  static constexpr dom::AudioSampleFormat value = dom::AudioSampleFormat::F32_planar;

  static_assert(static_cast<uint8_t>(dom::AudioSampleFormat::U8) == 0,
                "We rely on this in ContiguousEnumValues");
  static_assert(std::size(dom::binding_detail::EnumStrings<dom::AudioSampleFormat>::Values) - 1 == UnderlyingValue(value),
                "Mismatch between enum strings and enum count");
};


} // namespace mozilla

#endif // DOM_AUDIODATABINDING_H_
