#ifndef DOM_BINDINGNAMES_H_
#define DOM_BINDINGNAMES_H_

#include <stddef.h>
#include <stdint.h>
#include "mozilla/Attributes.h"

namespace mozilla::dom {

enum class BindingNamesOffset : uint16_t {
  ANGLE_instanced_arrays = 0,
  APZHitResultFlags = 23,
  AbortController = 41,
  AbortSignal = 57,
  AbstractRange = 69,
  AccessibleNode = 83,
  Addon = 98,
  AddonEvent = 104,
  AddonInstall = 115,
  AddonManager = 128,
  AddonManagerPermissions = 141,
  AnalyserNode = 165,
  Animation = 178,
  AnimationEffect = 188,
  AnimationEvent = 204,
  AnimationPlaybackEvent = 219,
  AnimationTimeline = 242,
  AnonymousContent = 260,
  Attr = 277,
  Audio = 282,
  AudioBuffer = 288,
  AudioBufferSourceNode = 300,
  AudioContext = 322,
  AudioData = 335,
  AudioDecoder = 345,
  AudioDestinationNode = 358,
  AudioEncoder = 379,
  AudioListener = 392,
  AudioNode = 406,
  AudioParam = 416,
  AudioParamMap = 427,
  AudioProcessingEvent = 441,
  AudioScheduledSourceNode = 462,
  AudioTrack = 487,
  AudioTrackList = 498,
  AudioWorklet = 513,
  AudioWorkletGlobalScope = 526,
  AudioWorkletNode = 550,
  AudioWorkletProcessor = 567,
  AuthenticatorAssertionResponse = 589,
  AuthenticatorAttestationResponse = 620,
  AuthenticatorResponse = 653,
  BarProp = 675,
  BaseAudioContext = 683,
  BatteryManager = 700,
  BeforeUnloadEvent = 715,
  BiquadFilterNode = 733,
  Blob = 750,
  BlobEvent = 755,
  BroadcastChannel = 765,
  BrowsingContext = 782,
  BrowsingContextGroup = 798,
  ByteLengthQueuingStrategy = 819,
  CDATASection = 845,
  CSPViolationReportBody = 858,
  CSS = 881,
  CSS2Properties = 885,
  CSSAnimation = 900,
  CSSConditionRule = 913,
  CSSContainerRule = 930,
  CSSCounterStyleRule = 947,
  CSSCustomPropertyRegisteredEvent = 967,
  CSSFontFaceRule = 1000,
  CSSFontFeatureValuesRule = 1016,
  CSSFontPaletteValuesRule = 1041,
  CSSGroupingRule = 1066,
  CSSImportRule = 1082,
  CSSKeyframeRule = 1096,
  CSSKeyframesRule = 1112,
  CSSLayerBlockRule = 1129,
  CSSLayerStatementRule = 1147,
  CSSMarginRule = 1169,
  CSSMediaRule = 1183,
  CSSMozDocumentRule = 1196,
  CSSNamespaceRule = 1215,
  CSSNestedDeclarations = 1232,
  CSSPageDescriptors = 1254,
  CSSPageRule = 1273,
  CSSPositionTryDescriptors = 1285,
  CSSPositionTryRule = 1311,
  CSSPropertyRule = 1330,
  CSSPseudoElement = 1346,
  CSSRule = 1363,
  CSSRuleList = 1371,
  CSSScopeRule = 1383,
  CSSStartingStyleRule = 1396,
  CSSStyleDeclaration = 1417,
  CSSStyleRule = 1437,
  CSSStyleSheet = 1450,
  CSSSupportsRule = 1464,
  CSSTransition = 1480,
  Cache = 1494,
  CacheStorage = 1500,
  CallbackDebuggerNotification = 1513,
  CanonicalBrowsingContext = 1542,
  CanvasCaptureMediaStream = 1567,
  CanvasGradient = 1592,
  CanvasPattern = 1607,
  CanvasRenderingContext2D = 1621,
  CaretPosition = 1646,
  CaretStateChangedEvent = 1660,
  ChannelMergerNode = 1683,
  ChannelSplitterNode = 1701,
  ChannelWrapper = 1721,
  CharacterData = 1736,
  CheckerboardReportService = 1750,
  ChildProcessMessageManager = 1776,
  ChildSHistory = 1803,
  ChromeMessageBroadcaster = 1817,
  ChromeMessageSender = 1842,
  ChromeNodeList = 1862,
  ChromeUtils = 1877,
  ChromeWorker = 1889,
  Client = 1902,
  Clients = 1909,
  Clipboard = 1917,
  ClipboardEvent = 1927,
  ClipboardItem = 1942,
  ClonedErrorHolder = 1956,
  CloseEvent = 1974,
  CloseWatcher = 1985,
  CommandEvent = 1998,
  Comment = 2011,
  CompositionEvent = 2019,
  CompressionStream = 2036,
  ConsoleInstance = 2054,
  ConstantSourceNode = 2070,
  ContentFrameMessageManager = 2089,
  ContentProcessMessageManager = 2116,
  ContentVisibilityAutoStateChangeEvent = 2145,
  ConvolverNode = 2183,
  CookieChangeEvent = 2197,
  CookieStore = 2215,
  CountQueuingStrategy = 2227,
  CreateOfferRequest = 2248,
  Credential = 2267,
  CredentialsContainer = 2278,
  Crypto = 2299,
  CryptoKey = 2306,
  CustomElementRegistry = 2316,
  CustomEvent = 2338,
  CustomStateSet = 2350,
  DOMException = 2365,
  DOMImplementation = 2378,
  DOMLocalization = 2396,
  DOMMatrix = 2412,
  DOMMatrixReadOnly = 2422,
  DOMParser = 2440,
  DOMPoint = 2450,
  DOMPointReadOnly = 2459,
  DOMQuad = 2476,
  DOMRect = 2484,
  DOMRectList = 2492,
  DOMRectReadOnly = 2504,
  DOMStringList = 2520,
  DOMStringMap = 2534,
  DOMTokenList = 2547,
  DataTransfer = 2560,
  DataTransferItem = 2573,
  DataTransferItemList = 2590,
  DebuggerNotification = 2611,
  DebuggerNotificationObserver = 2632,
  DecompressionStream = 2661,
  DedicatedWorkerGlobalScope = 2681,
  DelayNode = 2708,
  DeprecationReportBody = 2718,
  DeviceAcceleration = 2740,
  DeviceLightEvent = 2759,
  DeviceMotionEvent = 2776,
  DeviceOrientationEvent = 2794,
  DeviceRotationRate = 2817,
  Directory = 2836,
  Document = 2846,
  DocumentFragment = 2855,
  DocumentL10n = 2872,
  DocumentTimeline = 2885,
  DocumentType = 2902,
  DominatorTree = 2915,
  DragEvent = 2929,
  DynamicsCompressorNode = 2939,
  EXT_blend_minmax = 2962,
  EXT_color_buffer_float = 2979,
  EXT_color_buffer_half_float = 3002,
  EXT_depth_clamp = 3030,
  EXT_disjoint_timer_query = 3046,
  EXT_float_blend = 3071,
  EXT_frag_depth = 3087,
  EXT_sRGB = 3102,
  EXT_shader_texture_lod = 3111,
  EXT_texture_compression_bptc = 3134,
  EXT_texture_compression_rgtc = 3163,
  EXT_texture_filter_anisotropic = 3192,
  EXT_texture_norm16 = 3223,
  Element = 3242,
  ElementInternals = 3250,
  EncodedAudioChunk = 3267,
  EncodedVideoChunk = 3285,
  ErrorEvent = 3303,
  Event = 3314,
  EventCallbackDebuggerNotification = 3320,
  EventCounts = 3354,
  EventSource = 3366,
  EventTarget = 3378,
  Exception = 3390,
  ExtendableEvent = 3400,
  ExtendableMessageEvent = 3416,
  ExtensionAlarms = 3439,
  ExtensionBrowser = 3455,
  ExtensionBrowserSettings = 3472,
  ExtensionBrowserSettingsColorManagement = 3497,
  ExtensionDns = 3537,
  ExtensionEventManager = 3550,
  ExtensionMockAPI = 3572,
  ExtensionPort = 3589,
  ExtensionProxy = 3603,
  ExtensionRuntime = 3618,
  ExtensionScripting = 3635,
  ExtensionSetting = 3654,
  ExtensionTest = 3671,
  External = 3685,
  FeaturePolicy = 3694,
  FeaturePolicyViolationReportBody = 3708,
  FetchEvent = 3741,
  FetchObserver = 3752,
  File = 3766,
  FileList = 3771,
  FileReader = 3780,
  FileReaderSync = 3791,
  FileSystem = 3806,
  FileSystemDirectoryEntry = 3817,
  FileSystemDirectoryHandle = 3842,
  FileSystemDirectoryHandle_AsyncIterator = 3868,
  FileSystemDirectoryIterator = 3908,
  FileSystemDirectoryReader = 3936,
  FileSystemEntry = 3962,
  FileSystemFileEntry = 3978,
  FileSystemFileHandle = 3998,
  FileSystemHandle = 4019,
  FileSystemSyncAccessHandle = 4036,
  FileSystemWritableFileStream = 4063,
  Flex = 4092,
  FlexItemValues = 4097,
  FlexLineValues = 4112,
  FluentBundle = 4127,
  FluentBundleAsyncIterator = 4140,
  FluentBundleIterator = 4166,
  FluentPattern = 4187,
  FluentResource = 4201,
  FocusEvent = 4216,
  FontFace = 4227,
  FontFaceSet = 4236,
  FontFaceSetIterator = 4248,
  FontFaceSetLoadEvent = 4268,
  FormData = 4289,
  FormData_Iterator = 4298,
  FormDataEvent = 4316,
  FragmentDirective = 4330,
  FrameCrashedEvent = 4348,
  FrameLoader = 4366,
  GPU = 4378,
  GPUAdapter = 4382,
  GPUAdapterInfo = 4393,
  GPUBindGroup = 4408,
  GPUBindGroupLayout = 4421,
  GPUBuffer = 4440,
  GPUBufferUsage = 4450,
  GPUCanvasContext = 4465,
  GPUColorWrite = 4482,
  GPUCommandBuffer = 4496,
  GPUCommandEncoder = 4513,
  GPUCompilationInfo = 4531,
  GPUCompilationMessage = 4550,
  GPUComputePassEncoder = 4572,
  GPUComputePipeline = 4594,
  GPUDevice = 4613,
  GPUDeviceLostInfo = 4623,
  GPUError = 4641,
  GPUInternalError = 4650,
  GPUMapMode = 4667,
  GPUOutOfMemoryError = 4678,
  GPUPipelineLayout = 4698,
  GPUQuerySet = 4716,
  GPUQueue = 4728,
  GPURenderBundle = 4737,
  GPURenderBundleEncoder = 4753,
  GPURenderPassEncoder = 4776,
  GPURenderPipeline = 4797,
  GPUSampler = 4815,
  GPUShaderModule = 4826,
  GPUShaderStage = 4842,
  GPUSupportedFeatures = 4857,
  GPUSupportedLimits = 4878,
  GPUTexture = 4897,
  GPUTextureUsage = 4908,
  GPUTextureView = 4924,
  GPUUncapturedErrorEvent = 4939,
  GPUValidationError = 4963,
  GainNode = 4982,
  Gamepad = 4991,
  GamepadAxisMoveEvent = 4999,
  GamepadButton = 5020,
  GamepadButtonEvent = 5034,
  GamepadEvent = 5053,
  GamepadHapticActuator = 5066,
  GamepadLightIndicator = 5088,
  GamepadPose = 5110,
  GamepadServiceTest = 5122,
  GamepadTouch = 5141,
  Geolocation = 5154,
  GeolocationCoordinates = 5166,
  GeolocationPosition = 5189,
  GeolocationPositionError = 5209,
  GetUserMediaRequest = 5234,
  GleanBoolean = 5254,
  GleanCategory = 5267,
  GleanCounter = 5281,
  GleanCustomDistribution = 5294,
  GleanDatetime = 5318,
  GleanDenominator = 5332,
  GleanEvent = 5349,
  GleanImpl = 5360,
  GleanLabeled = 5370,
  GleanMemoryDistribution = 5383,
  GleanMetric = 5407,
  GleanNumerator = 5419,
  GleanObject = 5434,
  GleanPingsImpl = 5446,
  GleanQuantity = 5461,
  GleanRate = 5475,
  GleanString = 5485,
  GleanStringList = 5497,
  GleanText = 5513,
  GleanTimespan = 5523,
  GleanTimingDistribution = 5537,
  GleanUrl = 5561,
  GleanUuid = 5570,
  Grid = 5580,
  GridArea = 5585,
  GridDimension = 5594,
  GridLine = 5608,
  GridLines = 5617,
  GridTrack = 5627,
  GridTracks = 5637,
  HTMLAllCollection = 5648,
  HTMLAnchorElement = 5666,
  HTMLAreaElement = 5684,
  HTMLAudioElement = 5700,
  HTMLBRElement = 5717,
  HTMLBaseElement = 5731,
  HTMLBodyElement = 5747,
  HTMLButtonElement = 5763,
  HTMLCanvasElement = 5781,
  HTMLCollection = 5799,
  HTMLDListElement = 5814,
  HTMLDataElement = 5831,
  HTMLDataListElement = 5847,
  HTMLDetailsElement = 5867,
  HTMLDialogElement = 5886,
  HTMLDirectoryElement = 5904,
  HTMLDivElement = 5925,
  HTMLDocument = 5940,
  HTMLElement = 5953,
  HTMLEmbedElement = 5965,
  HTMLFieldSetElement = 5982,
  HTMLFontElement = 6002,
  HTMLFormControlsCollection = 6018,
  HTMLFormElement = 6045,
  HTMLFrameElement = 6061,
  HTMLFrameSetElement = 6078,
  HTMLHRElement = 6098,
  HTMLHeadElement = 6112,
  HTMLHeadingElement = 6128,
  HTMLHtmlElement = 6147,
  HTMLIFrameElement = 6163,
  HTMLImageElement = 6181,
  HTMLInputElement = 6198,
  HTMLLIElement = 6215,
  HTMLLabelElement = 6229,
  HTMLLegendElement = 6246,
  HTMLLinkElement = 6264,
  HTMLMapElement = 6280,
  HTMLMarqueeElement = 6295,
  HTMLMediaElement = 6314,
  HTMLMenuElement = 6331,
  HTMLMetaElement = 6347,
  HTMLMeterElement = 6363,
  HTMLModElement = 6380,
  HTMLOListElement = 6395,
  HTMLObjectElement = 6412,
  HTMLOptGroupElement = 6430,
  HTMLOptionElement = 6450,
  HTMLOptionsCollection = 6468,
  HTMLOutputElement = 6490,
  HTMLParagraphElement = 6508,
  HTMLParamElement = 6529,
  HTMLPictureElement = 6546,
  HTMLPreElement = 6565,
  HTMLProgressElement = 6580,
  HTMLQuoteElement = 6600,
  HTMLScriptElement = 6617,
  HTMLSelectElement = 6635,
  HTMLSlotElement = 6653,
  HTMLSourceElement = 6669,
  HTMLSpanElement = 6687,
  HTMLStyleElement = 6703,
  HTMLTableCaptionElement = 6720,
  HTMLTableCellElement = 6744,
  HTMLTableColElement = 6765,
  HTMLTableElement = 6785,
  HTMLTableRowElement = 6802,
  HTMLTableSectionElement = 6822,
  HTMLTemplateElement = 6846,
  HTMLTextAreaElement = 6866,
  HTMLTimeElement = 6886,
  HTMLTitleElement = 6902,
  HTMLTrackElement = 6919,
  HTMLUListElement = 6936,
  HTMLUnknownElement = 6953,
  HTMLVideoElement = 6972,
  HashChangeEvent = 6989,
  Headers = 7005,
  Headers_Iterator = 7013,
  HeapSnapshot = 7030,
  Highlight = 7043,
  HighlightRegistry = 7053,
  History = 7071,
  IDBCursor = 7079,
  IDBCursorWithValue = 7089,
  IDBDatabase = 7108,
  IDBFactory = 7120,
  IDBIndex = 7131,
  IDBKeyRange = 7140,
  IDBObjectStore = 7152,
  IDBOpenDBRequest = 7167,
  IDBRequest = 7184,
  IDBTransaction = 7195,
  IDBVersionChangeEvent = 7210,
  IIRFilterNode = 7232,
  IOUtils = 7246,
  IdentityCredential = 7254,
  IdleDeadline = 7273,
  Image = 7286,
  ImageBitmap = 7292,
  ImageBitmapRenderingContext = 7304,
  ImageCapture = 7332,
  ImageCaptureError = 7345,
  ImageCaptureErrorEvent = 7363,
  ImageData = 7386,
  ImageDecoder = 7396,
  ImageDocument = 7409,
  ImageTrack = 7423,
  ImageTrackList = 7434,
  InputEvent = 7449,
  InspectorCSSParser = 7460,
  InspectorFontFace = 7479,
  InspectorUtils = 7497,
  InstallTriggerImpl = 7512,
  IntersectionObserver = 7531,
  IntersectionObserverEntry = 7552,
  IntlUtils = 7578,
  InvokeEvent = 7588,
  JSProcessActorChild = 7600,
  JSProcessActorParent = 7620,
  JSWindowActorChild = 7641,
  JSWindowActorParent = 7660,
  KeyEvent = 7680,
  KeyboardEvent = 7689,
  KeyframeEffect = 7703,
  L10nFileSource = 7718,
  L10nOverlays = 7733,
  L10nRegistry = 7746,
  LargestContentfulPaint = 7759,
  LegacyMozTCPSocket = 7782,
  Localization = 7801,
  Location = 7814,
  Lock = 7823,
  LockManager = 7828,
  MIDIAccess = 7840,
  MIDIConnectionEvent = 7851,
  MIDIInput = 7871,
  MIDIInputMap = 7881,
  MIDIMessageEvent = 7894,
  MIDIOutput = 7911,
  MIDIOutputMap = 7922,
  MIDIPort = 7936,
  MLS = 7945,
  MLSGroupView = 7949,
  MOZ_debug = 7962,
  MatchGlob = 7972,
  MatchPattern = 7982,
  MatchPatternSet = 7995,
  MathMLElement = 8011,
  MediaCapabilities = 8025,
  MediaControlService = 8043,
  MediaController = 8063,
  MediaDeviceInfo = 8079,
  MediaDevices = 8095,
  MediaElementAudioSourceNode = 8108,
  MediaEncryptedEvent = 8136,
  MediaError = 8156,
  MediaKeyError = 8167,
  MediaKeyMessageEvent = 8181,
  MediaKeySession = 8202,
  MediaKeyStatusMap = 8218,
  MediaKeyStatusMap_Iterator = 8236,
  MediaKeySystemAccess = 8263,
  MediaKeys = 8284,
  MediaList = 8294,
  MediaMetadata = 8304,
  MediaQueryList = 8318,
  MediaQueryListEvent = 8333,
  MediaRecorder = 8353,
  MediaRecorderErrorEvent = 8367,
  MediaSession = 8391,
  MediaSource = 8404,
  MediaStream = 8416,
  MediaStreamAudioDestinationNode = 8428,
  MediaStreamAudioSourceNode = 8460,
  MediaStreamError = 8487,
  MediaStreamEvent = 8504,
  MediaStreamTrack = 8521,
  MediaStreamTrackAudioSourceNode = 8538,
  MediaStreamTrackEvent = 8570,
  MerchantValidationEvent = 8592,
  MessageBroadcaster = 8616,
  MessageChannel = 8635,
  MessageEvent = 8650,
  MessageListenerManager = 8663,
  MessagePort = 8686,
  MessageSender = 8698,
  MimeType = 8712,
  MimeTypeArray = 8721,
  MouseEvent = 8735,
  MouseScrollEvent = 8746,
  MozCanvasPrintState = 8763,
  MozDocumentMatcher = 8783,
  MozDocumentObserver = 8802,
  MozQueryInterface = 8822,
  MozSharedMap = 8840,
  MozSharedMap_Iterator = 8853,
  MozSharedMapChangeEvent = 8875,
  MozStorageAsyncStatementParams = 8899,
  MozStorageStatementParams = 8930,
  MozStorageStatementRow = 8956,
  MozWritableSharedMap = 8979,
  MutationEvent = 9000,
  MutationObserver = 9014,
  MutationRecord = 9031,
  NamedNodeMap = 9046,
  NavigateEvent = 9059,
  Navigation = 9073,
  NavigationActivation = 9084,
  NavigationCurrentEntryChangeEvent = 9105,
  NavigationDestination = 9139,
  NavigationHistoryEntry = 9161,
  NavigationPreloadManager = 9184,
  NavigationTransition = 9209,
  Navigator = 9230,
  NetworkInformation = 9240,
  Node = 9259,
  NodeFilter = 9264,
  NodeIterator = 9275,
  NodeList = 9288,
  Notification = 9297,
  NotificationEvent = 9310,
  NotifyPaintEvent = 9328,
  OES_draw_buffers_indexed = 9345,
  OES_element_index_uint = 9370,
  OES_fbo_render_mipmap = 9393,
  OES_standard_derivatives = 9415,
  OES_texture_float = 9440,
  OES_texture_float_linear = 9458,
  OES_texture_half_float = 9483,
  OES_texture_half_float_linear = 9506,
  OES_vertex_array_object = 9536,
  OVR_multiview2 = 9560,
  OfflineAudioCompletionEvent = 9575,
  OfflineAudioContext = 9603,
  OffscreenCanvas = 9623,
  OffscreenCanvasRenderingContext2D = 9639,
  Option = 9673,
  OscillatorNode = 9680,
  PageTransitionEvent = 9695,
  PaintRequest = 9715,
  PaintRequestList = 9728,
  PaintWorkletGlobalScope = 9745,
  PannerNode = 9769,
  ParentProcessMessageManager = 9780,
  Path2D = 9808,
  PathUtils = 9815,
  PaymentAddress = 9825,
  PaymentMethodChangeEvent = 9840,
  PaymentRequest = 9865,
  PaymentRequestUpdateEvent = 9880,
  PaymentResponse = 9906,
  Performance = 9922,
  PerformanceEntry = 9934,
  PerformanceEntryEvent = 9951,
  PerformanceEventTiming = 9973,
  PerformanceMark = 9996,
  PerformanceMeasure = 10012,
  PerformanceNavigation = 10031,
  PerformanceNavigationTiming = 10053,
  PerformanceObserver = 10081,
  PerformanceObserverEntryList = 10101,
  PerformancePaintTiming = 10130,
  PerformanceResourceTiming = 10153,
  PerformanceServerTiming = 10179,
  PerformanceTiming = 10203,
  PeriodicWave = 10221,
  PermissionStatus = 10234,
  Permissions = 10251,
  PlacesBookmark = 10263,
  PlacesBookmarkAddition = 10278,
  PlacesBookmarkChanged = 10301,
  PlacesBookmarkGuid = 10323,
  PlacesBookmarkKeyword = 10342,
  PlacesBookmarkMoved = 10364,
  PlacesBookmarkRemoved = 10384,
  PlacesBookmarkTags = 10406,
  PlacesBookmarkTime = 10425,
  PlacesBookmarkTitle = 10444,
  PlacesBookmarkUrl = 10464,
  PlacesEvent = 10482,
  PlacesEventCounts = 10494,
  PlacesFavicon = 10512,
  PlacesHistoryCleared = 10526,
  PlacesObservers = 10547,
  PlacesPurgeCaches = 10563,
  PlacesRanking = 10581,
  PlacesVisit = 10595,
  PlacesVisitRemoved = 10607,
  PlacesVisitTitle = 10626,
  PlacesWeakCallbackWrapper = 10643,
  Plugin = 10669,
  PluginArray = 10676,
  PluginCrashedEvent = 10688,
  PointerEvent = 10707,
  PopStateEvent = 10720,
  PopupBlockedEvent = 10734,
  PopupPositionedEvent = 10752,
  PositionStateEvent = 10773,
  PrecompiledScript = 10792,
  PrivateAttribution = 10810,
  ProcessMessageManager = 10829,
  ProcessingInstruction = 10851,
  ProgressEvent = 10873,
  PromiseDebugging = 10887,
  PromiseNativeHandler = 10904,
  PromiseRejectionEvent = 10925,
  PublicKeyCredential = 10947,
  PushEvent = 10967,
  PushManager = 10977,
  PushManagerImpl = 10989,
  PushMessageData = 11005,
  PushSubscription = 11021,
  PushSubscriptionChangeEvent = 11038,
  PushSubscriptionOptions = 11066,
  RadioNodeList = 11090,
  Range = 11104,
  ReadableByteStreamController = 11110,
  ReadableStream = 11139,
  ReadableStream_AsyncIterator = 11154,
  ReadableStreamBYOBReader = 11183,
  ReadableStreamBYOBRequest = 11208,
  ReadableStreamDefaultController = 11234,
  ReadableStreamDefaultReader = 11266,
  Report = 11294,
  ReportBody = 11301,
  ReportingObserver = 11312,
  Request = 11330,
  ResizeObserver = 11338,
  ResizeObserverEntry = 11353,
  ResizeObserverSize = 11373,
  Response = 11392,
  SVGAElement = 11401,
  SVGAngle = 11413,
  SVGAnimateElement = 11422,
  SVGAnimateMotionElement = 11440,
  SVGAnimateTransformElement = 11464,
  SVGAnimatedAngle = 11491,
  SVGAnimatedBoolean = 11508,
  SVGAnimatedEnumeration = 11527,
  SVGAnimatedInteger = 11550,
  SVGAnimatedLength = 11569,
  SVGAnimatedLengthList = 11587,
  SVGAnimatedNumber = 11609,
  SVGAnimatedNumberList = 11627,
  SVGAnimatedPreserveAspectRatio = 11649,
  SVGAnimatedRect = 11680,
  SVGAnimatedString = 11696,
  SVGAnimatedTransformList = 11714,
  SVGAnimationElement = 11739,
  SVGCircleElement = 11759,
  SVGClipPathElement = 11776,
  SVGComponentTransferFunctionElement = 11795,
  SVGDefsElement = 11831,
  SVGDescElement = 11846,
  SVGDiscardElement = 11861,
  SVGElement = 11879,
  SVGEllipseElement = 11890,
  SVGFEBlendElement = 11908,
  SVGFEColorMatrixElement = 11926,
  SVGFEComponentTransferElement = 11950,
  SVGFECompositeElement = 11980,
  SVGFEConvolveMatrixElement = 12002,
  SVGFEDiffuseLightingElement = 12029,
  SVGFEDisplacementMapElement = 12057,
  SVGFEDistantLightElement = 12085,
  SVGFEDropShadowElement = 12110,
  SVGFEFloodElement = 12133,
  SVGFEFuncAElement = 12151,
  SVGFEFuncBElement = 12169,
  SVGFEFuncGElement = 12187,
  SVGFEFuncRElement = 12205,
  SVGFEGaussianBlurElement = 12223,
  SVGFEImageElement = 12248,
  SVGFEMergeElement = 12266,
  SVGFEMergeNodeElement = 12284,
  SVGFEMorphologyElement = 12306,
  SVGFEOffsetElement = 12329,
  SVGFEPointLightElement = 12348,
  SVGFESpecularLightingElement = 12371,
  SVGFESpotLightElement = 12400,
  SVGFETileElement = 12422,
  SVGFETurbulenceElement = 12439,
  SVGFilterElement = 12462,
  SVGForeignObjectElement = 12479,
  SVGGElement = 12503,
  SVGGeometryElement = 12515,
  SVGGradientElement = 12534,
  SVGGraphicsElement = 12553,
  SVGImageElement = 12572,
  SVGLength = 12588,
  SVGLengthList = 12598,
  SVGLineElement = 12612,
  SVGLinearGradientElement = 12627,
  SVGMPathElement = 12652,
  SVGMarkerElement = 12668,
  SVGMaskElement = 12685,
  SVGMatrix = 12700,
  SVGMetadataElement = 12710,
  SVGNumber = 12729,
  SVGNumberList = 12739,
  SVGPathElement = 12753,
  SVGPathSegment = 12768,
  SVGPatternElement = 12783,
  SVGPoint = 12801,
  SVGPointList = 12810,
  SVGPolygonElement = 12823,
  SVGPolylineElement = 12841,
  SVGPreserveAspectRatio = 12860,
  SVGRadialGradientElement = 12883,
  SVGRect = 12908,
  SVGRectElement = 12916,
  SVGSVGElement = 12931,
  SVGScriptElement = 12945,
  SVGSetElement = 12962,
  SVGStopElement = 12976,
  SVGStringList = 12991,
  SVGStyleElement = 13005,
  SVGSwitchElement = 13021,
  SVGSymbolElement = 13038,
  SVGTSpanElement = 13055,
  SVGTextContentElement = 13071,
  SVGTextElement = 13093,
  SVGTextPathElement = 13108,
  SVGTextPositioningElement = 13127,
  SVGTitleElement = 13153,
  SVGTransform = 13169,
  SVGTransformList = 13182,
  SVGUnitTypes = 13199,
  SVGUseElement = 13212,
  SVGViewElement = 13226,
  Sanitizer = 13241,
  Scheduler = 13251,
  Screen = 13261,
  ScreenLuminance = 13268,
  ScreenOrientation = 13284,
  ScriptProcessorNode = 13302,
  ScrollAreaEvent = 13322,
  ScrollViewChangeEvent = 13338,
  SecurityPolicyViolationEvent = 13360,
  Selection = 13389,
  ServiceWorker = 13399,
  ServiceWorkerContainer = 13413,
  ServiceWorkerGlobalScope = 13436,
  ServiceWorkerRegistration = 13461,
  SessionStoreFormData = 13487,
  SessionStoreScrollData = 13508,
  SessionStoreUtils = 13531,
  ShadowRealmGlobalScope = 13549,
  ShadowRoot = 13572,
  SharedWorker = 13583,
  SharedWorkerGlobalScope = 13596,
  SimpleGestureEvent = 13620,
  SourceBuffer = 13639,
  SourceBufferList = 13652,
  SpeechGrammar = 13669,
  SpeechGrammarList = 13683,
  SpeechRecognition = 13701,
  SpeechRecognitionAlternative = 13719,
  SpeechRecognitionError = 13748,
  SpeechRecognitionEvent = 13771,
  SpeechRecognitionResult = 13794,
  SpeechRecognitionResultList = 13818,
  SpeechSynthesis = 13846,
  SpeechSynthesisErrorEvent = 13862,
  SpeechSynthesisEvent = 13888,
  SpeechSynthesisUtterance = 13909,
  SpeechSynthesisVoice = 13934,
  StaticRange = 13955,
  StereoPannerNode = 13967,
  Storage = 13984,
  StorageEvent = 13992,
  StorageManager = 14005,
  StreamFilter = 14020,
  StreamFilterDataEvent = 14033,
  StructuredCloneHolder = 14055,
  StructuredCloneTester = 14077,
  StyleSheet = 14099,
  StyleSheetApplicableStateChangeEvent = 14110,
  StyleSheetList = 14147,
  StyleSheetRemovedEvent = 14162,
  SubmitEvent = 14185,
  SubtleCrypto = 14197,
  SyncMessageSender = 14210,
  SyncReadFile = 14228,
  TCPServerSocket = 14241,
  TCPServerSocketEvent = 14257,
  TCPSocket = 14278,
  TCPSocketErrorEvent = 14288,
  TCPSocketEvent = 14308,
  TaskController = 14323,
  TaskPriorityChangeEvent = 14338,
  TaskSignal = 14362,
  TelemetryStopwatch = 14373,
  TestUtils = 14392,
  TestingDeprecatedInterface = 14402,
  Text = 14429,
  TextClause = 14434,
  TextDecoder = 14445,
  TextDecoderStream = 14457,
  TextEncoder = 14475,
  TextEncoderStream = 14487,
  TextEvent = 14505,
  TextMetrics = 14515,
  TextTrack = 14527,
  TextTrackCue = 14537,
  TextTrackCueList = 14550,
  TextTrackList = 14567,
  TimeEvent = 14581,
  TimeRanges = 14591,
  ToggleEvent = 14602,
  Touch = 14614,
  TouchEvent = 14620,
  TouchList = 14631,
  TrackEvent = 14641,
  TransformStream = 14652,
  TransformStreamDefaultController = 14668,
  TransitionEvent = 14701,
  TreeColumn = 14717,
  TreeColumns = 14728,
  TreeContentView = 14740,
  TreeWalker = 14756,
  TrustedHTML = 14767,
  TrustedScript = 14779,
  TrustedScriptURL = 14793,
  TrustedTypePolicy = 14810,
  TrustedTypePolicyFactory = 14828,
  UDPMessageEvent = 14853,
  UDPSocket = 14869,
  UIEvent = 14879,
  URL = 14887,
  URLSearchParams = 14891,
  URLSearchParams_Iterator = 14907,
  UniFFIPointer = 14932,
  UniFFIScaffolding = 14946,
  UserActivation = 14964,
  UserInteraction = 14979,
  UserProximityEvent = 14995,
  VRDisplay = 15014,
  VRDisplayCapabilities = 15024,
  VRDisplayEvent = 15046,
  VREyeParameters = 15061,
  VRFieldOfView = 15077,
  VRFrameData = 15091,
  VRMockController = 15103,
  VRMockDisplay = 15120,
  VRPose = 15134,
  VRServiceTest = 15141,
  VRStageParameters = 15155,
  VTTCue = 15173,
  VTTRegion = 15180,
  ValidityState = 15190,
  VideoColorSpace = 15204,
  VideoDecoder = 15220,
  VideoEncoder = 15233,
  VideoFrame = 15246,
  VideoPlaybackQuality = 15257,
  VideoTrack = 15278,
  VideoTrackList = 15289,
  ViewTransition = 15304,
  VisualViewport = 15319,
  WEBGL_color_buffer_float = 15334,
  WEBGL_compressed_texture_astc = 15359,
  WEBGL_compressed_texture_etc = 15389,
  WEBGL_compressed_texture_etc1 = 15418,
  WEBGL_compressed_texture_pvrtc = 15448,
  WEBGL_compressed_texture_s3tc = 15479,
  WEBGL_compressed_texture_s3tc_srgb = 15509,
  WEBGL_debug_renderer_info = 15544,
  WEBGL_debug_shaders = 15570,
  WEBGL_depth_texture = 15590,
  WEBGL_draw_buffers = 15610,
  WEBGL_explicit_present = 15629,
  WEBGL_lose_context = 15652,
  WEBGL_provoking_vertex = 15671,
  WGSLLanguageFeatures = 15694,
  WakeLock = 15715,
  WakeLockSentinel = 15724,
  WaveShaperNode = 15741,
  WebExtensionContentScript = 15756,
  WebExtensionPolicy = 15782,
  WebGL2RenderingContext = 15801,
  WebGLActiveInfo = 15824,
  WebGLBuffer = 15840,
  WebGLContextEvent = 15852,
  WebGLFramebuffer = 15870,
  WebGLProgram = 15887,
  WebGLQuery = 15900,
  WebGLRenderbuffer = 15911,
  WebGLRenderingContext = 15929,
  WebGLSampler = 15951,
  WebGLShader = 15964,
  WebGLShaderPrecisionFormat = 15976,
  WebGLSync = 16003,
  WebGLTexture = 16013,
  WebGLTransformFeedback = 16026,
  WebGLUniformLocation = 16049,
  WebGLVertexArrayObject = 16070,
  WebKitCSSMatrix = 16093,
  WebSocket = 16109,
  WebTransport = 16119,
  WebTransportBidirectionalStream = 16132,
  WebTransportDatagramDuplexStream = 16164,
  WebTransportError = 16197,
  WebTransportReceiveStream = 16215,
  WebTransportSendStream = 16241,
  WheelEvent = 16264,
  Window = 16275,
  WindowClient = 16282,
  WindowContext = 16295,
  WindowGlobalChild = 16309,
  WindowGlobalParent = 16327,
  WindowRoot = 16346,
  Worker = 16357,
  WorkerDebuggerGlobalScope = 16364,
  WorkerGlobalScope = 16390,
  WorkerLocation = 16408,
  WorkerNavigator = 16423,
  WorkerTestUtils = 16439,
  Worklet = 16455,
  WorkletGlobalScope = 16463,
  WritableStream = 16482,
  WritableStreamDefaultController = 16497,
  WritableStreamDefaultWriter = 16529,
  XMLDocument = 16557,
  XMLHttpRequest = 16569,
  XMLHttpRequestEventTarget = 16584,
  XMLHttpRequestUpload = 16610,
  XMLSerializer = 16631,
  XPathEvaluator = 16645,
  XPathExpression = 16660,
  XPathResult = 16676,
  XRBoundedReferenceSpace = 16688,
  XRFrame = 16712,
  XRInputSource = 16720,
  XRInputSourceArray = 16734,
  XRInputSourceEvent = 16753,
  XRInputSourcesChangeEvent = 16772,
  XRPose = 16798,
  XRReferenceSpace = 16805,
  XRReferenceSpaceEvent = 16822,
  XRRenderState = 16844,
  XRRigidTransform = 16858,
  XRSession = 16875,
  XRSessionEvent = 16885,
  XRSpace = 16900,
  XRSystem = 16908,
  XRView = 16917,
  XRViewerPose = 16924,
  XRViewport = 16937,
  XRWebGLLayer = 16948,
  XSLTProcessor = 16961,
  XULCommandEvent = 16975,
  XULElement = 16991,
  XULFrameElement = 17002,
  XULMenuElement = 17018,
  XULPopupElement = 17033,
  XULResizerElement = 17049,
  XULTextElement = 17067,
  XULTreeElement = 17082,
  console = 17097,
  webkitSpeechGrammar = 17105,
  webkitSpeechGrammarList = 17125,
  webkitSpeechRecognition = 17149,
  webkitURL = 17173,
};

namespace binding_detail {
extern const char sBindingNames[];
}  // namespace binding_detail

MOZ_ALWAYS_INLINE const char* BindingName(BindingNamesOffset aOffset) {
  return binding_detail::sBindingNames + static_cast<size_t>(aOffset);
}

} // namespace mozilla::dom


#endif // DOM_BINDINGNAMES_H_
