/* THIS FILE IS AUTOGENERATED FROM CredentialManagement.webidl BY Codegen.py - DO NOT EDIT */

#ifndef DOM_CREDENTIALMANAGEMENTBINDING_H_
#define DOM_CREDENTIALMANAGEMENTBINDING_H_

#include "IdentityCredentialBinding.h"
#include "WebAuthenticationBinding.h"
#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/EnumTypeTraits.h"
#include "mozilla/Span.h"
#include "mozilla/dom/AbortSignal.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"
#include "mozilla/dom/RootedDictionary.h"

namespace mozilla {
namespace dom {

class AbortSignal;
class Credential;
struct CredentialCreationOptionsAtoms;
struct CredentialRequestOptionsAtoms;
class CredentialsContainer;
struct IdentityCredentialInit;
struct IdentityCredentialRequestOptions;
struct NativePropertyHooks;
class ProtoAndIfaceCache;
struct PublicKeyCredentialCreationOptions;
struct PublicKeyCredentialRequestOptions;

} // namespace dom
} // namespace mozilla

namespace mozilla {

namespace dom {

enum class CredentialMediationRequirement : uint8_t {
  Silent,
  Optional,
  Conditional,
  Required,
};

namespace binding_detail {
template <> struct EnumStrings<CredentialMediationRequirement> {
  static constexpr nsLiteralCString Values[4] {
    "silent"_ns,
    "optional"_ns,
    "conditional"_ns,
    "required"_ns,
  };
};
} // namespace binding_detail

bool
ToJSValue(JSContext* aCx, CredentialMediationRequirement aArgument, JS::MutableHandle<JS::Value> aValue);


struct CredentialCreationOptions : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Optional<IdentityCredentialInit> mIdentity;
  MOZ_INIT_OUTSIDE_CTOR Optional<PublicKeyCredentialCreationOptions> mPublicKey;
  MOZ_INIT_OUTSIDE_CTOR Optional<OwningNonNull<mozilla::dom::AbortSignal>> mSignal;

  CredentialCreationOptions();

  explicit inline CredentialCreationOptions(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  CredentialCreationOptions(CredentialCreationOptions&& aOther) = default;

private:
  CredentialCreationOptions(const CredentialCreationOptions&) = delete;
  CredentialCreationOptions& operator=(const CredentialCreationOptions&) = delete;

  static bool
  InitIds(JSContext* cx, CredentialCreationOptionsAtoms* atomsCache);

public:
  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  inline void
  TraverseForCC(nsCycleCollectionTraversalCallback& aCallback, uint32_t aFlags)
  {
    ImplCycleCollectionTraverse(aCallback, mSignal, "mSignal", aFlags);
  }

  inline void
  UnlinkForCC()
  {
    ImplCycleCollectionUnlink(mSignal);
  }
};

namespace binding_detail {
struct FastCredentialCreationOptions : public CredentialCreationOptions
{
  inline FastCredentialCreationOptions()
    : CredentialCreationOptions(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct CredentialRequestOptions : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Optional<IdentityCredentialRequestOptions> mIdentity;
  MOZ_INIT_OUTSIDE_CTOR CredentialMediationRequirement mMediation;
  MOZ_INIT_OUTSIDE_CTOR Optional<PublicKeyCredentialRequestOptions> mPublicKey;
  MOZ_INIT_OUTSIDE_CTOR Optional<OwningNonNull<mozilla::dom::AbortSignal>> mSignal;

  CredentialRequestOptions();

  explicit inline CredentialRequestOptions(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  CredentialRequestOptions(CredentialRequestOptions&& aOther) = default;

private:
  CredentialRequestOptions(const CredentialRequestOptions&) = delete;
  CredentialRequestOptions& operator=(const CredentialRequestOptions&) = delete;

  static bool
  InitIds(JSContext* cx, CredentialRequestOptionsAtoms* atomsCache);

public:
  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  inline void
  TraverseForCC(nsCycleCollectionTraversalCallback& aCallback, uint32_t aFlags)
  {
    ImplCycleCollectionTraverse(aCallback, mSignal, "mSignal", aFlags);
  }

  inline void
  UnlinkForCC()
  {
    ImplCycleCollectionUnlink(mSignal);
  }
};

namespace binding_detail {
struct FastCredentialRequestOptions : public CredentialRequestOptions
{
  inline FastCredentialRequestOptions()
    : CredentialRequestOptions(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace Credential_Binding {

  typedef mozilla::dom::Credential NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  bool
  Wrap(JSContext* aCx, mozilla::dom::Credential* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, DefineInterfaceProperty aDefineOnGlobal);

  JS::Handle<JSObject*>
  GetProtoObjectHandle(JSContext* aCx);

  JSObject*
  GetProtoObject(JSContext* aCx);

  JS::Handle<JSObject*>
  GetConstructorObjectHandle(JSContext* aCx);

  inline bool CreateAndDefineOnGlobal(JSContext* aCx)
  {
    // Get the interface or namespace object for this class. This will
    // create the object as needed and always define the properties for
    // it on the global. The caller should make sure the interface or
    // namespace is exposed on the global before calling this.
    return GetPerInterfaceObjectHandle(aCx, constructors::id::Credential,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::Always);

  }

} // namespace Credential_Binding



namespace CredentialsContainer_Binding {

  typedef mozilla::dom::CredentialsContainer NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  bool
  Wrap(JSContext* aCx, mozilla::dom::CredentialsContainer* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, DefineInterfaceProperty aDefineOnGlobal);

  JS::Handle<JSObject*>
  GetConstructorObjectHandle(JSContext* aCx);

  inline bool CreateAndDefineOnGlobal(JSContext* aCx)
  {
    // Get the interface or namespace object for this class. This will
    // create the object as needed and always define the properties for
    // it on the global. The caller should make sure the interface or
    // namespace is exposed on the global before calling this.
    return GetPerInterfaceObjectHandle(aCx, constructors::id::CredentialsContainer,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::Always);

  }

} // namespace CredentialsContainer_Binding



} // namespace dom


template <>
struct MaxContiguousEnumValue<dom::CredentialMediationRequirement>
{
  static constexpr dom::CredentialMediationRequirement value = dom::CredentialMediationRequirement::Required;

  static_assert(static_cast<uint8_t>(dom::CredentialMediationRequirement::Silent) == 0,
                "We rely on this in ContiguousEnumValues");
  static_assert(std::size(dom::binding_detail::EnumStrings<dom::CredentialMediationRequirement>::Values) - 1 == UnderlyingValue(value),
                "Mismatch between enum strings and enum count");
};


} // namespace mozilla

#endif // DOM_CREDENTIALMANAGEMENTBINDING_H_
