/* THIS FILE IS AUTOGENERATED FROM FrameLoader.webidl BY Codegen.py - DO NOT EDIT */

#ifndef DOM_FRAMELOADERBINDING_H_
#define DOM_FRAMELOADERBINDING_H_

#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/EnumTypeTraits.h"
#include "mozilla/Span.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"

class nsFrameLoader;

namespace mozilla {
namespace dom {

struct NativePropertyHooks;
struct PrintPreviewSuccessInfoAtoms;
class ProtoAndIfaceCache;

} // namespace dom
} // namespace mozilla

namespace mozilla {

namespace dom {

enum class PrintPreviewOrientation : uint8_t {
  Landscape,
  Portrait,
  Unspecified,
};

namespace binding_detail {
template <> struct EnumStrings<PrintPreviewOrientation> {
  static constexpr nsLiteralCString Values[3] {
    "landscape"_ns,
    "portrait"_ns,
    "unspecified"_ns,
  };
};
} // namespace binding_detail

bool
ToJSValue(JSContext* aCx, PrintPreviewOrientation aArgument, JS::MutableHandle<JS::Value> aValue);


struct PrintPreviewSuccessInfo : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR bool mHasSelection;
  MOZ_INIT_OUTSIDE_CTOR bool mHasSelfSelection;
  MOZ_INIT_OUTSIDE_CTOR bool mIsEmpty;
  MOZ_INIT_OUTSIDE_CTOR PrintPreviewOrientation mOrientation;
  MOZ_INIT_OUTSIDE_CTOR Nullable<float> mPageHeight;
  MOZ_INIT_OUTSIDE_CTOR Nullable<float> mPageWidth;
  MOZ_INIT_OUTSIDE_CTOR uint32_t mSheetCount;
  MOZ_INIT_OUTSIDE_CTOR uint32_t mTotalPageCount;

  PrintPreviewSuccessInfo();

  explicit inline PrintPreviewSuccessInfo(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  PrintPreviewSuccessInfo(PrintPreviewSuccessInfo&& aOther) = default;

  explicit inline PrintPreviewSuccessInfo(const PrintPreviewSuccessInfo& aOther)
  {
    *this = aOther;
  }

  bool
  Init(const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceDictionary(JSTracer* trc);

  PrintPreviewSuccessInfo&
  operator=(const PrintPreviewSuccessInfo& aOther);

private:
  static bool
  InitIds(JSContext* cx, PrintPreviewSuccessInfoAtoms* atomsCache);
};

namespace binding_detail {
struct FastPrintPreviewSuccessInfo : public PrintPreviewSuccessInfo
{
  inline FastPrintPreviewSuccessInfo()
    : PrintPreviewSuccessInfo(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace FrameLoader_Binding {

  typedef nsFrameLoader NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  bool
  Wrap(JSContext* aCx, nsFrameLoader* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, DefineInterfaceProperty aDefineOnGlobal);

  JS::Handle<JSObject*>
  GetConstructorObjectHandle(JSContext* aCx);

  inline bool CreateAndDefineOnGlobal(JSContext* aCx)
  {
    // Get the interface or namespace object for this class. This will
    // create the object as needed and always define the properties for
    // it on the global. The caller should make sure the interface or
    // namespace is exposed on the global before calling this.
    return GetPerInterfaceObjectHandle(aCx, constructors::id::FrameLoader,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::Always);

  }

} // namespace FrameLoader_Binding



} // namespace dom


template <>
struct MaxContiguousEnumValue<dom::PrintPreviewOrientation>
{
  static constexpr dom::PrintPreviewOrientation value = dom::PrintPreviewOrientation::Unspecified;

  static_assert(static_cast<uint8_t>(dom::PrintPreviewOrientation::Landscape) == 0,
                "We rely on this in ContiguousEnumValues");
  static_assert(std::size(dom::binding_detail::EnumStrings<dom::PrintPreviewOrientation>::Values) - 1 == UnderlyingValue(value),
                "Mismatch between enum strings and enum count");
};


} // namespace mozilla

#endif // DOM_FRAMELOADERBINDING_H_
