/* THIS FILE IS AUTOGENERATED FROM HTMLVideoElement.webidl BY Codegen.py - DO NOT EDIT */

#ifndef DOM_HTMLVIDEOELEMENTBINDING_H_
#define DOM_HTMLVIDEOELEMENTBINDING_H_

#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/CallbackFunction.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"
#include "mozilla/dom/ToJSValue.h"

namespace mozilla {
namespace dom {

class HTMLVideoElement;
struct NativePropertyHooks;
class ProtoAndIfaceCache;
struct VideoFrameCallbackMetadata;
struct VideoFrameCallbackMetadataAtoms;
class VideoFrameRequestCallback;

} // namespace dom
} // namespace mozilla

namespace mozilla::dom {

struct VideoFrameCallbackMetadata : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Optional<double> mCaptureTime;
  MOZ_INIT_OUTSIDE_CTOR double mExpectedDisplayTime;
  MOZ_INIT_OUTSIDE_CTOR uint32_t mHeight;
  MOZ_INIT_OUTSIDE_CTOR double mMediaTime;
  MOZ_INIT_OUTSIDE_CTOR double mPresentationTime;
  MOZ_INIT_OUTSIDE_CTOR uint32_t mPresentedFrames;
  MOZ_INIT_OUTSIDE_CTOR Optional<double> mProcessingDuration;
  MOZ_INIT_OUTSIDE_CTOR Optional<double> mReceiveTime;
  MOZ_INIT_OUTSIDE_CTOR Optional<uint32_t> mRtpTimestamp;
  MOZ_INIT_OUTSIDE_CTOR uint32_t mWidth;

  VideoFrameCallbackMetadata();

  explicit inline VideoFrameCallbackMetadata(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  VideoFrameCallbackMetadata(VideoFrameCallbackMetadata&& aOther) = default;

  explicit inline VideoFrameCallbackMetadata(const VideoFrameCallbackMetadata& aOther)
  {
    *this = aOther;
  }

  bool
  Init(const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceDictionary(JSTracer* trc);

  VideoFrameCallbackMetadata&
  operator=(const VideoFrameCallbackMetadata& aOther);

private:
  static bool
  InitIds(JSContext* cx, VideoFrameCallbackMetadataAtoms* atomsCache);
};

namespace binding_detail {
struct FastVideoFrameCallbackMetadata : public VideoFrameCallbackMetadata
{
  inline FastVideoFrameCallbackMetadata()
    : VideoFrameCallbackMetadata(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


class VideoFrameRequestCallback : public CallbackFunction
{
public:
  explicit inline VideoFrameRequestCallback(JSContext* aCx, JS::Handle<JSObject*> aCallback, JS::Handle<JSObject*> aCallbackGlobal, nsIGlobalObject* aIncumbentGlobal)
    : CallbackFunction(aCx, aCallback, aCallbackGlobal, aIncumbentGlobal)
  {
    MOZ_ASSERT(JS::IsCallable(mCallback));
  }

  explicit inline VideoFrameRequestCallback(JSObject* aCallback, JSObject* aCallbackGlobal, const FastCallbackConstructor& )
    : CallbackFunction(aCallback, aCallbackGlobal, FastCallbackConstructor())
  {
    MOZ_ASSERT(JS::IsCallable(mCallback));
  }

  explicit inline VideoFrameRequestCallback(JSObject* aCallback, JSObject* aCallbackGlobal, JSObject* aAsyncStack, nsIGlobalObject* aIncumbentGlobal)
    : CallbackFunction(aCallback, aCallbackGlobal, aAsyncStack, aIncumbentGlobal)
  {
    MOZ_ASSERT(JS::IsCallable(mCallback));
  }

  explicit inline VideoFrameRequestCallback(CallbackFunction* aOther)
    : CallbackFunction(aOther)
  {
  }

  template <typename T>
  MOZ_CAN_RUN_SCRIPT inline void
  Call(const T& thisVal, double now, const VideoFrameCallbackMetadata& metadata, ErrorResult& aRv, const char* aExecutionReason = nullptr, ExceptionHandling aExceptionHandling = eReportExceptions, JS::Realm* aRealm = nullptr)
  {
    MOZ_ASSERT(!aRv.Failed(), "Don't pass an already-failed ErrorResult to a callback!");
    if (!aExecutionReason) {
      aExecutionReason = "VideoFrameRequestCallback";
    }
    CallSetup s(this, aRv, aExecutionReason, aExceptionHandling, aRealm);
    if (!s.GetContext()) {
      MOZ_ASSERT(aRv.Failed());
      return;
    }
    JS::Rooted<JS::Value> thisValJS(s.GetContext());
    if (!ToJSValue(s.GetContext(), thisVal, &thisValJS)) {
      aRv.Throw(NS_ERROR_FAILURE);
      return;
    }
    return Call(s.GetCallContext(), thisValJS, now, metadata, aRv);
  }

  MOZ_CAN_RUN_SCRIPT inline void
  Call(double now, const VideoFrameCallbackMetadata& metadata, ErrorResult& aRv, const char* aExecutionReason = nullptr, ExceptionHandling aExceptionHandling = eReportExceptions, JS::Realm* aRealm = nullptr)
  {
    MOZ_ASSERT(!aRv.Failed(), "Don't pass an already-failed ErrorResult to a callback!");
    if (!aExecutionReason) {
      aExecutionReason = "VideoFrameRequestCallback";
    }
    CallSetup s(this, aRv, aExecutionReason, aExceptionHandling, aRealm);
    if (!s.GetContext()) {
      MOZ_ASSERT(aRv.Failed());
      return;
    }
    return Call(s.GetCallContext(), JS::UndefinedHandleValue, now, metadata, aRv);
  }

  template <typename T>
  MOZ_CAN_RUN_SCRIPT inline void
  Call(const T& thisVal, double now, const VideoFrameCallbackMetadata& metadata, const char* aExecutionReason = nullptr)
  {
    return Call(thisVal, now, metadata, IgnoreErrors(), aExecutionReason);
  }

  MOZ_CAN_RUN_SCRIPT inline void
  Call(double now, const VideoFrameCallbackMetadata& metadata, const char* aExecutionReason = nullptr)
  {
    return Call(now, metadata, IgnoreErrors(), aExecutionReason, eReportExceptions, nullptr);
  }

  inline bool
  operator==(const VideoFrameRequestCallback& aOther) const
  {
    return CallbackFunction::operator==(aOther);
  }

private:
  MOZ_CAN_RUN_SCRIPT void Call(BindingCallContext& cx, JS::Handle<JS::Value> aThisVal, double now, const VideoFrameCallbackMetadata& metadata, ErrorResult& aRv);
};


namespace binding_detail {
class FastVideoFrameRequestCallback : public VideoFrameRequestCallback
{
public:
  explicit inline FastVideoFrameRequestCallback(JSObject* aCallback, JSObject* aCallbackGlobal)
    : VideoFrameRequestCallback(aCallback, aCallbackGlobal, FastCallbackConstructor())
  {
  }

  inline void
  Trace(JSTracer* aTracer)
  {
    VideoFrameRequestCallback::Trace(aTracer);
  }

  inline void
  FinishSlowJSInitIfMoreThanOneOwner(JSContext* aCx)
  {
    VideoFrameRequestCallback::FinishSlowJSInitIfMoreThanOneOwner(aCx);
  }
};
} // namespace binding_detail


namespace HTMLVideoElement_Binding {

  typedef mozilla::dom::HTMLVideoElement NativeType;

  bool
  Wrap(JSContext* aCx, mozilla::dom::HTMLVideoElement* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, DefineInterfaceProperty aDefineOnGlobal);

  JS::Handle<JSObject*>
  GetConstructorObjectHandle(JSContext* aCx);

  inline bool CreateAndDefineOnGlobal(JSContext* aCx)
  {
    // Get the interface or namespace object for this class. This will
    // create the object as needed and always define the properties for
    // it on the global. The caller should make sure the interface or
    // namespace is exposed on the global before calling this.
    return GetPerInterfaceObjectHandle(aCx, constructors::id::HTMLVideoElement,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::Always);

  }

} // namespace HTMLVideoElement_Binding



} // namespace mozilla::dom

#endif // DOM_HTMLVIDEOELEMENTBINDING_H_
