/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED FROM PromiseRejectionEvent.webidl BY Codegen.py - DO NOT EDIT */

#ifndef DOM_PROMISEREJECTIONEVENT_H_
#define DOM_PROMISEREJECTIONEVENT_H_

#include "mozilla/Attributes.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/Event.h"
#include "mozilla/dom/PromiseRejectionEventBinding.h"

struct JSContext;
namespace mozilla::dom {

class PromiseRejectionEvent : public Event
{
public:
  NS_DECL_ISUPPORTS_INHERITED
  NS_DECL_CYCLE_COLLECTION_SCRIPT_HOLDER_CLASS_INHERITED(PromiseRejectionEvent, Event)

protected:
  virtual ~PromiseRejectionEvent();
  explicit PromiseRejectionEvent(mozilla::dom::EventTarget* aOwner);

  JS::Heap<JSObject*> mPromise;
  JS::Heap<JS::Value> mReason;

public:
  void
  GetReason(JS::MutableHandle<JS::Value> aRetVal) const;

  PromiseRejectionEvent* AsPromiseRejectionEvent() override;

  JSObject* WrapObjectInternal(JSContext* aCx, JS::Handle<JSObject*> aGivenProto) override;

  static already_AddRefed<PromiseRejectionEvent> Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const PromiseRejectionEventInit& aEventInitDict);

  static already_AddRefed<PromiseRejectionEvent> Constructor(const GlobalObject& aGlobal, const nsAString& aType, const PromiseRejectionEventInit& aEventInitDict);

  void GetRejectedPromise(JSContext* cx, JS::MutableHandle<JSObject*> aRetVal) const;

  void GetReason(JSContext* cx, JS::MutableHandle<JS::Value> aRetVal) const;
};

} // namespace mozilla::dom

#endif // DOM_PROMISEREJECTIONEVENT_H_
