/* THIS FILE IS AUTOGENERATED FROM TCPSocket.webidl BY Codegen.py - DO NOT EDIT */

#ifndef DOM_TCPSOCKETBINDING_H_
#define DOM_TCPSOCKETBINDING_H_

#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/EnumTypeTraits.h"
#include "mozilla/Span.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"

namespace mozilla {
namespace dom {

class LegacyMozTCPSocket;
struct NativePropertyHooks;
class ProtoAndIfaceCache;
struct SocketOptionsAtoms;
class TCPSocket;

} // namespace dom
} // namespace mozilla

namespace mozilla {

namespace dom {

enum class TCPSocketBinaryType : uint8_t {
  Arraybuffer,
  String,
};

namespace binding_detail {
template <> struct EnumStrings<TCPSocketBinaryType> {
  static constexpr nsLiteralCString Values[2] {
    "arraybuffer"_ns,
    "string"_ns,
  };
};
} // namespace binding_detail

bool
ToJSValue(JSContext* aCx, TCPSocketBinaryType aArgument, JS::MutableHandle<JS::Value> aValue);


enum class TCPReadyState : uint8_t {
  Connecting,
  Open,
  Closing,
  Closed,
};

namespace binding_detail {
template <> struct EnumStrings<TCPReadyState> {
  static constexpr nsLiteralCString Values[4] {
    "connecting"_ns,
    "open"_ns,
    "closing"_ns,
    "closed"_ns,
  };
};
} // namespace binding_detail

bool
ToJSValue(JSContext* aCx, TCPReadyState aArgument, JS::MutableHandle<JS::Value> aValue);


struct SocketOptions : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR TCPSocketBinaryType mBinaryType;
  MOZ_INIT_OUTSIDE_CTOR bool mUseSecureTransport;

  SocketOptions();

  explicit inline SocketOptions(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  SocketOptions(SocketOptions&& aOther) = default;

  explicit inline SocketOptions(const SocketOptions& aOther)
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  SocketOptions&
  operator=(const SocketOptions& aOther);

private:
  static bool
  InitIds(JSContext* cx, SocketOptionsAtoms* atomsCache);
};

namespace binding_detail {
struct FastSocketOptions : public SocketOptions
{
  inline FastSocketOptions()
    : SocketOptions(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace LegacyMozTCPSocket_Binding {

  typedef mozilla::dom::LegacyMozTCPSocket NativeType;

  bool
  Wrap(JSContext* aCx, mozilla::dom::LegacyMozTCPSocket* aObject, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, DefineInterfaceProperty aDefineOnGlobal);

} // namespace LegacyMozTCPSocket_Binding



namespace TCPSocket_Binding {

  typedef mozilla::dom::TCPSocket NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  bool
  Wrap(JSContext* aCx, mozilla::dom::TCPSocket* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, DefineInterfaceProperty aDefineOnGlobal);

  JS::Handle<JSObject*>
  GetConstructorObjectHandle(JSContext* aCx);

  inline bool CreateAndDefineOnGlobal(JSContext* aCx)
  {
    // Get the interface or namespace object for this class. This will
    // create the object as needed and always define the properties for
    // it on the global. The caller should make sure the interface or
    // namespace is exposed on the global before calling this.
    return GetPerInterfaceObjectHandle(aCx, constructors::id::TCPSocket,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::Always);

  }

} // namespace TCPSocket_Binding



} // namespace dom


template <>
struct MaxContiguousEnumValue<dom::TCPSocketBinaryType>
{
  static constexpr dom::TCPSocketBinaryType value = dom::TCPSocketBinaryType::String;

  static_assert(static_cast<uint8_t>(dom::TCPSocketBinaryType::Arraybuffer) == 0,
                "We rely on this in ContiguousEnumValues");
  static_assert(std::size(dom::binding_detail::EnumStrings<dom::TCPSocketBinaryType>::Values) - 1 == UnderlyingValue(value),
                "Mismatch between enum strings and enum count");
};

template <>
struct MaxContiguousEnumValue<dom::TCPReadyState>
{
  static constexpr dom::TCPReadyState value = dom::TCPReadyState::Closed;

  static_assert(static_cast<uint8_t>(dom::TCPReadyState::Connecting) == 0,
                "We rely on this in ContiguousEnumValues");
  static_assert(std::size(dom::binding_detail::EnumStrings<dom::TCPReadyState>::Values) - 1 == UnderlyingValue(value),
                "Mismatch between enum strings and enum count");
};


} // namespace mozilla

#endif // DOM_TCPSOCKETBINDING_H_
