// -*- mode: C++ -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

#ifndef mozilla_GleanXpcomMetrics_h
#define mozilla_GleanXpcomMetrics_h

#include "mozilla/glean/bindings/MetricTypes.h"

namespace mozilla::glean {

namespace cycle_collector {
  /**
   * generated from cycle_collector.async_snow_white_freeing
   * Time spent on one asynchronous SnowWhite freeing (ms)
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_ASYNC_SNOW_WHITE_FREEING.
   */
  constexpr impl::TimingDistributionMetric async_snow_white_freeing(5582);

  /**
   * generated from cycle_collector.collected
   * Number of objects collected by the cycle collector
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_COLLECTED.
   */
  constexpr impl::CustomDistributionMetric collected(5583);

  /**
   * generated from cycle_collector.deferred_finalize_async
   * Pause time for asynchronous deferred finalization (ms)
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram DEFERRED_FINALIZE_ASYNC.
   */
  constexpr impl::TimingDistributionMetric deferred_finalize_async(5584);

  /**
   * generated from cycle_collector.finish_igc
   */
  enum class FinishIgcLabel: uint16_t {
    eFalse = 0,
    eTrue = 1,
    e__Other__,
  };
  /**
   * Cycle collection finished an incremental GC
   * This metric was generated to correspond to the Legacy Telemetry boolean histogram CYCLE_COLLECTOR_FINISH_IGC.
   */
  constexpr impl::Labeled<impl::CounterMetric, FinishIgcLabel> finish_igc(5585);

  /**
   * generated from cycle_collector.full
   * Full pause time for one cycle collection, including preparation (ms)
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_FULL.
   */
  constexpr impl::TimingDistributionMetric full(5586);

  /**
   * generated from cycle_collector.max_pause
   * Longest pause for an individual slice of one cycle collection, including preparation (ms)
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_MAX_PAUSE.
   */
  constexpr impl::TimingDistributionMetric max_pause(5587);

  /**
   * generated from cycle_collector.need_gc
   */
  enum class NeedGcLabel: uint16_t {
    eFalse = 0,
    eTrue = 1,
    e__Other__,
  };
  /**
   * Needed garbage collection before cycle collection.
   * This metric was generated to correspond to the Legacy Telemetry boolean histogram CYCLE_COLLECTOR_NEED_GC.
   */
  constexpr impl::Labeled<impl::CounterMetric, NeedGcLabel> need_gc(5588);

  /**
   * generated from cycle_collector.slice_during_idle
   * Percent of cycle collector slice done during idle time
   * This metric was generated to correspond to the Legacy Telemetry linear histogram CYCLE_COLLECTOR_SLICE_DURING_IDLE.
   */
  constexpr impl::CustomDistributionMetric slice_during_idle(5589);

  /**
   * generated from cycle_collector.sync_skippable
   */
  enum class SyncSkippableLabel: uint16_t {
    eFalse = 0,
    eTrue = 1,
    e__Other__,
  };
  /**
   * Cycle collection synchronously ran forget skippable
   * This metric was generated to correspond to the Legacy Telemetry boolean histogram CYCLE_COLLECTOR_SYNC_SKIPPABLE.
   */
  constexpr impl::Labeled<impl::CounterMetric, SyncSkippableLabel> sync_skippable(5590);

  /**
   * generated from cycle_collector.time
   * Time spent on one cycle collection (ms)
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR.
   */
  constexpr impl::TimingDistributionMetric time(5591);

  /**
   * generated from cycle_collector.time_between
   * Time spent in between cycle collections (seconds)
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_TIME_BETWEEN.
   */
  constexpr impl::TimingDistributionMetric time_between(5592);

  /**
   * generated from cycle_collector.visited_gced
   * Number of JS objects visited by the cycle collector
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_VISITED_GCED.
   */
  constexpr impl::CustomDistributionMetric visited_gced(5593);

  /**
   * generated from cycle_collector.visited_ref_counted
   * Number of ref counted objects visited by the cycle collector
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_VISITED_REF_COUNTED.
   */
  constexpr impl::CustomDistributionMetric visited_ref_counted(5594);

  /**
   * generated from cycle_collector.worker_collected
   * Number of objects collected by the cycle collector in a worker
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_WORKER_COLLECTED.
   */
  constexpr impl::CustomDistributionMetric worker_collected(5595);

  /**
   * generated from cycle_collector.worker_need_gc
   */
  enum class WorkerNeedGcLabel: uint16_t {
    eFalse = 0,
    eTrue = 1,
    e__Other__,
  };
  /**
   * Needed garbage collection before cycle collection in a worker.
   * This metric was generated to correspond to the Legacy Telemetry boolean histogram CYCLE_COLLECTOR_WORKER_NEED_GC.
   */
  constexpr impl::Labeled<impl::CounterMetric, WorkerNeedGcLabel> worker_need_gc(5596);

  /**
   * generated from cycle_collector.worker_time
   * Time spent on one cycle collection in a worker (ms)
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_WORKER.
   */
  constexpr impl::TimingDistributionMetric worker_time(5597);

  /**
   * generated from cycle_collector.worker_visited_gced
   * Number of JS objects visited by the cycle collector in a worker
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_WORKER_VISITED_GCED.
   */
  constexpr impl::CustomDistributionMetric worker_visited_gced(5598);

  /**
   * generated from cycle_collector.worker_visited_ref_counted
   * Number of ref counted objects visited by the cycle collector in a worker
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_WORKER_VISITED_REF_COUNTED.
   */
  constexpr impl::CustomDistributionMetric worker_visited_ref_counted(5599);
}

namespace memory_phc {
  /**
   * generated from memory_phc.slop
   * Over-allocation due to PHC's rounding (aka internal fragmentation).  Measured in bytes.
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_PHC_SLOP.
   */
  constexpr impl::MemoryDistributionMetric slop(5600);

  /**
   * generated from memory_phc.slots_allocated
   * Number of PHC slots currently allocated
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_PHC_SLOTS_ALLOCATED.
   */
  constexpr impl::CustomDistributionMetric slots_allocated(5601);

  /**
   * generated from memory_phc.slots_freed
   * Number of PHC slots allocated-then-freed
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_PHC_SLOTS_FREED.
   */
  constexpr impl::CustomDistributionMetric slots_freed(5602);
}

namespace memory_watcher {
  /**
   * generated from memory_watcher.on_high_memory_stats
   */
  struct OnHighMemoryStatsExtra {
    mozilla::Maybe<nsCString> value;

    std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
      nsTArray<nsCString> extraKeys;
      nsTArray<nsCString> extraValues;
      if (value) {
        extraKeys.AppendElement()->AssignASCII("value");
        extraValues.EmplaceBack(value.value());
      }
      return std::make_tuple(std::move(extraKeys), std::move(extraValues));
    }
  };
  /**
   * This event is recorded when the memory situation is no longer low. The "stats" object consists of three numbers comma-delimited: 1) how many times a tab was unloaded 2) how many memory-pressure events were dispatched 3) how long we were in the low-memory situation in seconds This event was generated to correspond to the Legacy Telemetry event memory_watcher.on_high_memory#stats.
   */
  constexpr impl::EventMetric<OnHighMemoryStatsExtra> on_high_memory_stats(5603);
}

namespace timer_thread {
  /**
   * generated from timer_thread.timers_fired_per_wakeup
   * How many timers were processed in a single wake-up of the Timer Thread.
   */
  constexpr impl::CustomDistributionMetric timers_fired_per_wakeup(5604);
}

} // namespace mozilla::glean

#endif // mozilla_GleanXpcomMetrics_h
