/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM $SRCDIR/uriloader/base/nsIWebProgress.idl
 */

#ifndef __gen_nsIWebProgress_h__
#define __gen_nsIWebProgress_h__


#include "nsISupports.h"

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class mozIDOMWindowProxy; /* forward declaration */

class nsIEventTarget; /* forward declaration */

class nsIRequest; /* forward declaration */

class nsIWebProgressListener; /* forward declaration */

namespace mozilla {
namespace dom {
class BrowsingContext; /* webidl BrowsingContext */
} // namespace dom
} // namespace mozilla


/* starting interface:    nsIWebProgress */
#define NS_IWEBPROGRESS_IID_STR "c4d64640-b332-4db6-a2a5-e08566000dc9"

#define NS_IWEBPROGRESS_IID \
  {0xc4d64640, 0xb332, 0x4db6, \
    { 0xa2, 0xa5, 0xe0, 0x85, 0x66, 0x00, 0x0d, 0xc9 }}

class NS_NO_VTABLE nsIWebProgress : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IWEBPROGRESS_IID)

  /* Used by ToJSValue to check which scriptable interface is implemented. */
  using ScriptableInterfaceType = nsIWebProgress;

  enum {
    NOTIFY_STATE_REQUEST = 1U,
    NOTIFY_STATE_DOCUMENT = 2U,
    NOTIFY_STATE_NETWORK = 4U,
    NOTIFY_STATE_WINDOW = 8U,
    NOTIFY_STATE_ALL = 15U,
    NOTIFY_PROGRESS = 16U,
    NOTIFY_STATUS = 32U,
    NOTIFY_SECURITY = 64U,
    NOTIFY_LOCATION = 128U,
    NOTIFY_REFRESH = 256U,
    NOTIFY_CONTENT_BLOCKING = 512U,
    NOTIFY_ALL = 1023U
  };

  /* void addProgressListener (in nsIWebProgressListener aListener, in unsigned long aNotifyMask); */
  NS_IMETHOD AddProgressListener(nsIWebProgressListener *aListener, uint32_t aNotifyMask) = 0;

  /* void removeProgressListener (in nsIWebProgressListener aListener); */
  NS_IMETHOD RemoveProgressListener(nsIWebProgressListener *aListener) = 0;

  /* [binaryname(BrowsingContextXPCOM)] readonly attribute BrowsingContext browsingContext; */
  NS_IMETHOD GetBrowsingContextXPCOM(mozilla::dom::BrowsingContext **aBrowsingContext) = 0;

  /* [noscript,nostdcall,notxpcom] BrowsingContext getBrowsingContext (); */
  virtual mozilla::dom::BrowsingContext * GetBrowsingContext(void) = 0;

  /* readonly attribute mozIDOMWindowProxy DOMWindow; */
  NS_IMETHOD GetDOMWindow(mozIDOMWindowProxy **aDOMWindow) = 0;

  /* readonly attribute boolean isTopLevel; */
  NS_IMETHOD GetIsTopLevel(bool *aIsTopLevel) = 0;

  /* readonly attribute boolean isLoadingDocument; */
  NS_IMETHOD GetIsLoadingDocument(bool *aIsLoadingDocument) = 0;

  /* readonly attribute unsigned long loadType; */
  NS_IMETHOD GetLoadType(uint32_t *aLoadType) = 0;

  /* attribute nsIEventTarget target; */
  NS_IMETHOD GetTarget(nsIEventTarget **aTarget) = 0;
  NS_IMETHOD SetTarget(nsIEventTarget *aTarget) = 0;

  /* readonly attribute nsIRequest documentRequest; */
  NS_IMETHOD GetDocumentRequest(nsIRequest **aDocumentRequest) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIWebProgress, NS_IWEBPROGRESS_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIWEBPROGRESS \
  NS_IMETHOD AddProgressListener(nsIWebProgressListener *aListener, uint32_t aNotifyMask) override; \
  NS_IMETHOD RemoveProgressListener(nsIWebProgressListener *aListener) override; \
  NS_IMETHOD GetBrowsingContextXPCOM(mozilla::dom::BrowsingContext **aBrowsingContext) override; \
  virtual mozilla::dom::BrowsingContext * GetBrowsingContext(void) override; \
  NS_IMETHOD GetDOMWindow(mozIDOMWindowProxy **aDOMWindow) override; \
  NS_IMETHOD GetIsTopLevel(bool *aIsTopLevel) override; \
  NS_IMETHOD GetIsLoadingDocument(bool *aIsLoadingDocument) override; \
  NS_IMETHOD GetLoadType(uint32_t *aLoadType) override; \
  NS_IMETHOD GetTarget(nsIEventTarget **aTarget) override; \
  NS_IMETHOD SetTarget(nsIEventTarget *aTarget) override; \
  NS_IMETHOD GetDocumentRequest(nsIRequest **aDocumentRequest) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIWEBPROGRESS \
  nsresult AddProgressListener(nsIWebProgressListener *aListener, uint32_t aNotifyMask); \
  nsresult RemoveProgressListener(nsIWebProgressListener *aListener); \
  nsresult GetBrowsingContextXPCOM(mozilla::dom::BrowsingContext **aBrowsingContext); \
  mozilla::dom::BrowsingContext * GetBrowsingContext(void); \
  nsresult GetDOMWindow(mozIDOMWindowProxy **aDOMWindow); \
  nsresult GetIsTopLevel(bool *aIsTopLevel); \
  nsresult GetIsLoadingDocument(bool *aIsLoadingDocument); \
  nsresult GetLoadType(uint32_t *aLoadType); \
  nsresult GetTarget(nsIEventTarget **aTarget); \
  nsresult SetTarget(nsIEventTarget *aTarget); \
  nsresult GetDocumentRequest(nsIRequest **aDocumentRequest); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIWEBPROGRESS(_to) \
  NS_IMETHOD AddProgressListener(nsIWebProgressListener *aListener, uint32_t aNotifyMask) override { return _to AddProgressListener(aListener, aNotifyMask); } \
  NS_IMETHOD RemoveProgressListener(nsIWebProgressListener *aListener) override { return _to RemoveProgressListener(aListener); } \
  NS_IMETHOD GetBrowsingContextXPCOM(mozilla::dom::BrowsingContext **aBrowsingContext) override { return _to GetBrowsingContextXPCOM(aBrowsingContext); } \
  virtual mozilla::dom::BrowsingContext * GetBrowsingContext(void) override { return _to GetBrowsingContext(); } \
  NS_IMETHOD GetDOMWindow(mozIDOMWindowProxy **aDOMWindow) override { return _to GetDOMWindow(aDOMWindow); } \
  NS_IMETHOD GetIsTopLevel(bool *aIsTopLevel) override { return _to GetIsTopLevel(aIsTopLevel); } \
  NS_IMETHOD GetIsLoadingDocument(bool *aIsLoadingDocument) override { return _to GetIsLoadingDocument(aIsLoadingDocument); } \
  NS_IMETHOD GetLoadType(uint32_t *aLoadType) override { return _to GetLoadType(aLoadType); } \
  NS_IMETHOD GetTarget(nsIEventTarget **aTarget) override { return _to GetTarget(aTarget); } \
  NS_IMETHOD SetTarget(nsIEventTarget *aTarget) override { return _to SetTarget(aTarget); } \
  NS_IMETHOD GetDocumentRequest(nsIRequest **aDocumentRequest) override { return _to GetDocumentRequest(aDocumentRequest); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIWEBPROGRESS(_to) \
  NS_IMETHOD AddProgressListener(nsIWebProgressListener *aListener, uint32_t aNotifyMask) override { return !_to ? NS_ERROR_NULL_POINTER : _to->AddProgressListener(aListener, aNotifyMask); } \
  NS_IMETHOD RemoveProgressListener(nsIWebProgressListener *aListener) override { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveProgressListener(aListener); } \
  NS_IMETHOD GetBrowsingContextXPCOM(mozilla::dom::BrowsingContext **aBrowsingContext) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBrowsingContextXPCOM(aBrowsingContext); } \
  virtual mozilla::dom::BrowsingContext * GetBrowsingContext(void) override; \
  NS_IMETHOD GetDOMWindow(mozIDOMWindowProxy **aDOMWindow) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDOMWindow(aDOMWindow); } \
  NS_IMETHOD GetIsTopLevel(bool *aIsTopLevel) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsTopLevel(aIsTopLevel); } \
  NS_IMETHOD GetIsLoadingDocument(bool *aIsLoadingDocument) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsLoadingDocument(aIsLoadingDocument); } \
  NS_IMETHOD GetLoadType(uint32_t *aLoadType) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLoadType(aLoadType); } \
  NS_IMETHOD GetTarget(nsIEventTarget **aTarget) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTarget(aTarget); } \
  NS_IMETHOD SetTarget(nsIEventTarget *aTarget) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetTarget(aTarget); } \
  NS_IMETHOD GetDocumentRequest(nsIRequest **aDocumentRequest) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDocumentRequest(aDocumentRequest); } 


#endif /* __gen_nsIWebProgress_h__ */
