#include "mozilla/EnumTypeTraits.h"
#include "mozilla/dom/BindingNames.h"

namespace mozilla::dom {

namespace binding_detail {

const char sBindingNames[] = {
  /*     0 */ "ANGLE_instanced_arrays" "\0"
  /*    23 */ "APZHitResultFlags" "\0"
  /*    41 */ "AbortController" "\0"
  /*    57 */ "AbortSignal" "\0"
  /*    69 */ "AbstractRange" "\0"
  /*    83 */ "AccessibleNode" "\0"
  /*    98 */ "Addon" "\0"
  /*   104 */ "AddonEvent" "\0"
  /*   115 */ "AddonInstall" "\0"
  /*   128 */ "AddonManager" "\0"
  /*   141 */ "AddonManagerPermissions" "\0"
  /*   165 */ "AnalyserNode" "\0"
  /*   178 */ "Animation" "\0"
  /*   188 */ "AnimationEffect" "\0"
  /*   204 */ "AnimationEvent" "\0"
  /*   219 */ "AnimationPlaybackEvent" "\0"
  /*   242 */ "AnimationTimeline" "\0"
  /*   260 */ "AnonymousContent" "\0"
  /*   277 */ "Attr" "\0"
  /*   282 */ "Audio" "\0"
  /*   288 */ "AudioBuffer" "\0"
  /*   300 */ "AudioBufferSourceNode" "\0"
  /*   322 */ "AudioContext" "\0"
  /*   335 */ "AudioData" "\0"
  /*   345 */ "AudioDecoder" "\0"
  /*   358 */ "AudioDestinationNode" "\0"
  /*   379 */ "AudioEncoder" "\0"
  /*   392 */ "AudioListener" "\0"
  /*   406 */ "AudioNode" "\0"
  /*   416 */ "AudioParam" "\0"
  /*   427 */ "AudioParamMap" "\0"
  /*   441 */ "AudioProcessingEvent" "\0"
  /*   462 */ "AudioScheduledSourceNode" "\0"
  /*   487 */ "AudioTrack" "\0"
  /*   498 */ "AudioTrackList" "\0"
  /*   513 */ "AudioWorklet" "\0"
  /*   526 */ "AudioWorkletGlobalScope" "\0"
  /*   550 */ "AudioWorkletNode" "\0"
  /*   567 */ "AudioWorkletProcessor" "\0"
  /*   589 */ "AuthenticatorAssertionResponse" "\0"
  /*   620 */ "AuthenticatorAttestationResponse" "\0"
  /*   653 */ "AuthenticatorResponse" "\0"
  /*   675 */ "BarProp" "\0"
  /*   683 */ "BaseAudioContext" "\0"
  /*   700 */ "BatteryManager" "\0"
  /*   715 */ "BeforeUnloadEvent" "\0"
  /*   733 */ "BiquadFilterNode" "\0"
  /*   750 */ "Blob" "\0"
  /*   755 */ "BlobEvent" "\0"
  /*   765 */ "BroadcastChannel" "\0"
  /*   782 */ "BrowsingContext" "\0"
  /*   798 */ "BrowsingContextGroup" "\0"
  /*   819 */ "ByteLengthQueuingStrategy" "\0"
  /*   845 */ "CDATASection" "\0"
  /*   858 */ "CSPViolationReportBody" "\0"
  /*   881 */ "CSS" "\0"
  /*   885 */ "CSS2Properties" "\0"
  /*   900 */ "CSSAnimation" "\0"
  /*   913 */ "CSSConditionRule" "\0"
  /*   930 */ "CSSContainerRule" "\0"
  /*   947 */ "CSSCounterStyleRule" "\0"
  /*   967 */ "CSSCustomPropertyRegisteredEvent" "\0"
  /*  1000 */ "CSSFontFaceRule" "\0"
  /*  1016 */ "CSSFontFeatureValuesRule" "\0"
  /*  1041 */ "CSSFontPaletteValuesRule" "\0"
  /*  1066 */ "CSSGroupingRule" "\0"
  /*  1082 */ "CSSImportRule" "\0"
  /*  1096 */ "CSSKeyframeRule" "\0"
  /*  1112 */ "CSSKeyframesRule" "\0"
  /*  1129 */ "CSSLayerBlockRule" "\0"
  /*  1147 */ "CSSLayerStatementRule" "\0"
  /*  1169 */ "CSSMarginRule" "\0"
  /*  1183 */ "CSSMediaRule" "\0"
  /*  1196 */ "CSSMozDocumentRule" "\0"
  /*  1215 */ "CSSNamespaceRule" "\0"
  /*  1232 */ "CSSNestedDeclarations" "\0"
  /*  1254 */ "CSSPageDescriptors" "\0"
  /*  1273 */ "CSSPageRule" "\0"
  /*  1285 */ "CSSPositionTryDescriptors" "\0"
  /*  1311 */ "CSSPositionTryRule" "\0"
  /*  1330 */ "CSSPropertyRule" "\0"
  /*  1346 */ "CSSPseudoElement" "\0"
  /*  1363 */ "CSSRule" "\0"
  /*  1371 */ "CSSRuleList" "\0"
  /*  1383 */ "CSSScopeRule" "\0"
  /*  1396 */ "CSSStartingStyleRule" "\0"
  /*  1417 */ "CSSStyleDeclaration" "\0"
  /*  1437 */ "CSSStyleRule" "\0"
  /*  1450 */ "CSSStyleSheet" "\0"
  /*  1464 */ "CSSSupportsRule" "\0"
  /*  1480 */ "CSSTransition" "\0"
  /*  1494 */ "Cache" "\0"
  /*  1500 */ "CacheStorage" "\0"
  /*  1513 */ "CallbackDebuggerNotification" "\0"
  /*  1542 */ "CanonicalBrowsingContext" "\0"
  /*  1567 */ "CanvasCaptureMediaStream" "\0"
  /*  1592 */ "CanvasGradient" "\0"
  /*  1607 */ "CanvasPattern" "\0"
  /*  1621 */ "CanvasRenderingContext2D" "\0"
  /*  1646 */ "CaretPosition" "\0"
  /*  1660 */ "CaretStateChangedEvent" "\0"
  /*  1683 */ "ChannelMergerNode" "\0"
  /*  1701 */ "ChannelSplitterNode" "\0"
  /*  1721 */ "ChannelWrapper" "\0"
  /*  1736 */ "CharacterData" "\0"
  /*  1750 */ "CheckerboardReportService" "\0"
  /*  1776 */ "ChildProcessMessageManager" "\0"
  /*  1803 */ "ChildSHistory" "\0"
  /*  1817 */ "ChromeMessageBroadcaster" "\0"
  /*  1842 */ "ChromeMessageSender" "\0"
  /*  1862 */ "ChromeNodeList" "\0"
  /*  1877 */ "ChromeUtils" "\0"
  /*  1889 */ "ChromeWorker" "\0"
  /*  1902 */ "Client" "\0"
  /*  1909 */ "Clients" "\0"
  /*  1917 */ "Clipboard" "\0"
  /*  1927 */ "ClipboardEvent" "\0"
  /*  1942 */ "ClipboardItem" "\0"
  /*  1956 */ "ClonedErrorHolder" "\0"
  /*  1974 */ "CloseEvent" "\0"
  /*  1985 */ "CloseWatcher" "\0"
  /*  1998 */ "CommandEvent" "\0"
  /*  2011 */ "Comment" "\0"
  /*  2019 */ "CompositionEvent" "\0"
  /*  2036 */ "CompressionStream" "\0"
  /*  2054 */ "ConsoleInstance" "\0"
  /*  2070 */ "ConstantSourceNode" "\0"
  /*  2089 */ "ContentFrameMessageManager" "\0"
  /*  2116 */ "ContentProcessMessageManager" "\0"
  /*  2145 */ "ContentVisibilityAutoStateChangeEvent" "\0"
  /*  2183 */ "ConvolverNode" "\0"
  /*  2197 */ "CookieChangeEvent" "\0"
  /*  2215 */ "CookieStore" "\0"
  /*  2227 */ "CountQueuingStrategy" "\0"
  /*  2248 */ "CreateOfferRequest" "\0"
  /*  2267 */ "Credential" "\0"
  /*  2278 */ "CredentialsContainer" "\0"
  /*  2299 */ "Crypto" "\0"
  /*  2306 */ "CryptoKey" "\0"
  /*  2316 */ "CustomElementRegistry" "\0"
  /*  2338 */ "CustomEvent" "\0"
  /*  2350 */ "CustomStateSet" "\0"
  /*  2365 */ "DOMException" "\0"
  /*  2378 */ "DOMImplementation" "\0"
  /*  2396 */ "DOMLocalization" "\0"
  /*  2412 */ "DOMMatrix" "\0"
  /*  2422 */ "DOMMatrixReadOnly" "\0"
  /*  2440 */ "DOMParser" "\0"
  /*  2450 */ "DOMPoint" "\0"
  /*  2459 */ "DOMPointReadOnly" "\0"
  /*  2476 */ "DOMQuad" "\0"
  /*  2484 */ "DOMRect" "\0"
  /*  2492 */ "DOMRectList" "\0"
  /*  2504 */ "DOMRectReadOnly" "\0"
  /*  2520 */ "DOMStringList" "\0"
  /*  2534 */ "DOMStringMap" "\0"
  /*  2547 */ "DOMTokenList" "\0"
  /*  2560 */ "DataTransfer" "\0"
  /*  2573 */ "DataTransferItem" "\0"
  /*  2590 */ "DataTransferItemList" "\0"
  /*  2611 */ "DebuggerNotification" "\0"
  /*  2632 */ "DebuggerNotificationObserver" "\0"
  /*  2661 */ "DecompressionStream" "\0"
  /*  2681 */ "DedicatedWorkerGlobalScope" "\0"
  /*  2708 */ "DelayNode" "\0"
  /*  2718 */ "DeprecationReportBody" "\0"
  /*  2740 */ "DeviceAcceleration" "\0"
  /*  2759 */ "DeviceLightEvent" "\0"
  /*  2776 */ "DeviceMotionEvent" "\0"
  /*  2794 */ "DeviceOrientationEvent" "\0"
  /*  2817 */ "DeviceRotationRate" "\0"
  /*  2836 */ "Directory" "\0"
  /*  2846 */ "Document" "\0"
  /*  2855 */ "DocumentFragment" "\0"
  /*  2872 */ "DocumentL10n" "\0"
  /*  2885 */ "DocumentTimeline" "\0"
  /*  2902 */ "DocumentType" "\0"
  /*  2915 */ "DominatorTree" "\0"
  /*  2929 */ "DragEvent" "\0"
  /*  2939 */ "DynamicsCompressorNode" "\0"
  /*  2962 */ "EXT_blend_minmax" "\0"
  /*  2979 */ "EXT_color_buffer_float" "\0"
  /*  3002 */ "EXT_color_buffer_half_float" "\0"
  /*  3030 */ "EXT_depth_clamp" "\0"
  /*  3046 */ "EXT_disjoint_timer_query" "\0"
  /*  3071 */ "EXT_float_blend" "\0"
  /*  3087 */ "EXT_frag_depth" "\0"
  /*  3102 */ "EXT_sRGB" "\0"
  /*  3111 */ "EXT_shader_texture_lod" "\0"
  /*  3134 */ "EXT_texture_compression_bptc" "\0"
  /*  3163 */ "EXT_texture_compression_rgtc" "\0"
  /*  3192 */ "EXT_texture_filter_anisotropic" "\0"
  /*  3223 */ "EXT_texture_norm16" "\0"
  /*  3242 */ "Element" "\0"
  /*  3250 */ "ElementInternals" "\0"
  /*  3267 */ "EncodedAudioChunk" "\0"
  /*  3285 */ "EncodedVideoChunk" "\0"
  /*  3303 */ "ErrorEvent" "\0"
  /*  3314 */ "Event" "\0"
  /*  3320 */ "EventCallbackDebuggerNotification" "\0"
  /*  3354 */ "EventCounts" "\0"
  /*  3366 */ "EventSource" "\0"
  /*  3378 */ "EventTarget" "\0"
  /*  3390 */ "Exception" "\0"
  /*  3400 */ "ExtendableEvent" "\0"
  /*  3416 */ "ExtendableMessageEvent" "\0"
  /*  3439 */ "ExtensionAlarms" "\0"
  /*  3455 */ "ExtensionBrowser" "\0"
  /*  3472 */ "ExtensionBrowserSettings" "\0"
  /*  3497 */ "ExtensionBrowserSettingsColorManagement" "\0"
  /*  3537 */ "ExtensionDns" "\0"
  /*  3550 */ "ExtensionEventManager" "\0"
  /*  3572 */ "ExtensionMockAPI" "\0"
  /*  3589 */ "ExtensionPort" "\0"
  /*  3603 */ "ExtensionProxy" "\0"
  /*  3618 */ "ExtensionRuntime" "\0"
  /*  3635 */ "ExtensionScripting" "\0"
  /*  3654 */ "ExtensionSetting" "\0"
  /*  3671 */ "ExtensionTest" "\0"
  /*  3685 */ "External" "\0"
  /*  3694 */ "FeaturePolicy" "\0"
  /*  3708 */ "FeaturePolicyViolationReportBody" "\0"
  /*  3741 */ "FetchEvent" "\0"
  /*  3752 */ "FetchObserver" "\0"
  /*  3766 */ "File" "\0"
  /*  3771 */ "FileList" "\0"
  /*  3780 */ "FileReader" "\0"
  /*  3791 */ "FileReaderSync" "\0"
  /*  3806 */ "FileSystem" "\0"
  /*  3817 */ "FileSystemDirectoryEntry" "\0"
  /*  3842 */ "FileSystemDirectoryHandle" "\0"
  /*  3868 */ "FileSystemDirectoryHandle AsyncIterator" "\0"
  /*  3908 */ "FileSystemDirectoryIterator" "\0"
  /*  3936 */ "FileSystemDirectoryReader" "\0"
  /*  3962 */ "FileSystemEntry" "\0"
  /*  3978 */ "FileSystemFileEntry" "\0"
  /*  3998 */ "FileSystemFileHandle" "\0"
  /*  4019 */ "FileSystemHandle" "\0"
  /*  4036 */ "FileSystemSyncAccessHandle" "\0"
  /*  4063 */ "FileSystemWritableFileStream" "\0"
  /*  4092 */ "Flex" "\0"
  /*  4097 */ "FlexItemValues" "\0"
  /*  4112 */ "FlexLineValues" "\0"
  /*  4127 */ "FluentBundle" "\0"
  /*  4140 */ "FluentBundleAsyncIterator" "\0"
  /*  4166 */ "FluentBundleIterator" "\0"
  /*  4187 */ "FluentPattern" "\0"
  /*  4201 */ "FluentResource" "\0"
  /*  4216 */ "FocusEvent" "\0"
  /*  4227 */ "FontFace" "\0"
  /*  4236 */ "FontFaceSet" "\0"
  /*  4248 */ "FontFaceSetIterator" "\0"
  /*  4268 */ "FontFaceSetLoadEvent" "\0"
  /*  4289 */ "FormData" "\0"
  /*  4298 */ "FormData Iterator" "\0"
  /*  4316 */ "FormDataEvent" "\0"
  /*  4330 */ "FragmentDirective" "\0"
  /*  4348 */ "FrameCrashedEvent" "\0"
  /*  4366 */ "FrameLoader" "\0"
  /*  4378 */ "GPU" "\0"
  /*  4382 */ "GPUAdapter" "\0"
  /*  4393 */ "GPUAdapterInfo" "\0"
  /*  4408 */ "GPUBindGroup" "\0"
  /*  4421 */ "GPUBindGroupLayout" "\0"
  /*  4440 */ "GPUBuffer" "\0"
  /*  4450 */ "GPUBufferUsage" "\0"
  /*  4465 */ "GPUCanvasContext" "\0"
  /*  4482 */ "GPUColorWrite" "\0"
  /*  4496 */ "GPUCommandBuffer" "\0"
  /*  4513 */ "GPUCommandEncoder" "\0"
  /*  4531 */ "GPUCompilationInfo" "\0"
  /*  4550 */ "GPUCompilationMessage" "\0"
  /*  4572 */ "GPUComputePassEncoder" "\0"
  /*  4594 */ "GPUComputePipeline" "\0"
  /*  4613 */ "GPUDevice" "\0"
  /*  4623 */ "GPUDeviceLostInfo" "\0"
  /*  4641 */ "GPUError" "\0"
  /*  4650 */ "GPUInternalError" "\0"
  /*  4667 */ "GPUMapMode" "\0"
  /*  4678 */ "GPUOutOfMemoryError" "\0"
  /*  4698 */ "GPUPipelineLayout" "\0"
  /*  4716 */ "GPUQuerySet" "\0"
  /*  4728 */ "GPUQueue" "\0"
  /*  4737 */ "GPURenderBundle" "\0"
  /*  4753 */ "GPURenderBundleEncoder" "\0"
  /*  4776 */ "GPURenderPassEncoder" "\0"
  /*  4797 */ "GPURenderPipeline" "\0"
  /*  4815 */ "GPUSampler" "\0"
  /*  4826 */ "GPUShaderModule" "\0"
  /*  4842 */ "GPUShaderStage" "\0"
  /*  4857 */ "GPUSupportedFeatures" "\0"
  /*  4878 */ "GPUSupportedLimits" "\0"
  /*  4897 */ "GPUTexture" "\0"
  /*  4908 */ "GPUTextureUsage" "\0"
  /*  4924 */ "GPUTextureView" "\0"
  /*  4939 */ "GPUUncapturedErrorEvent" "\0"
  /*  4963 */ "GPUValidationError" "\0"
  /*  4982 */ "GainNode" "\0"
  /*  4991 */ "Gamepad" "\0"
  /*  4999 */ "GamepadAxisMoveEvent" "\0"
  /*  5020 */ "GamepadButton" "\0"
  /*  5034 */ "GamepadButtonEvent" "\0"
  /*  5053 */ "GamepadEvent" "\0"
  /*  5066 */ "GamepadHapticActuator" "\0"
  /*  5088 */ "GamepadLightIndicator" "\0"
  /*  5110 */ "GamepadPose" "\0"
  /*  5122 */ "GamepadServiceTest" "\0"
  /*  5141 */ "GamepadTouch" "\0"
  /*  5154 */ "Geolocation" "\0"
  /*  5166 */ "GeolocationCoordinates" "\0"
  /*  5189 */ "GeolocationPosition" "\0"
  /*  5209 */ "GeolocationPositionError" "\0"
  /*  5234 */ "GetUserMediaRequest" "\0"
  /*  5254 */ "GleanBoolean" "\0"
  /*  5267 */ "GleanCategory" "\0"
  /*  5281 */ "GleanCounter" "\0"
  /*  5294 */ "GleanCustomDistribution" "\0"
  /*  5318 */ "GleanDatetime" "\0"
  /*  5332 */ "GleanDenominator" "\0"
  /*  5349 */ "GleanEvent" "\0"
  /*  5360 */ "GleanImpl" "\0"
  /*  5370 */ "GleanLabeled" "\0"
  /*  5383 */ "GleanMemoryDistribution" "\0"
  /*  5407 */ "GleanMetric" "\0"
  /*  5419 */ "GleanNumerator" "\0"
  /*  5434 */ "GleanObject" "\0"
  /*  5446 */ "GleanPingsImpl" "\0"
  /*  5461 */ "GleanQuantity" "\0"
  /*  5475 */ "GleanRate" "\0"
  /*  5485 */ "GleanString" "\0"
  /*  5497 */ "GleanStringList" "\0"
  /*  5513 */ "GleanText" "\0"
  /*  5523 */ "GleanTimespan" "\0"
  /*  5537 */ "GleanTimingDistribution" "\0"
  /*  5561 */ "GleanUrl" "\0"
  /*  5570 */ "GleanUuid" "\0"
  /*  5580 */ "Grid" "\0"
  /*  5585 */ "GridArea" "\0"
  /*  5594 */ "GridDimension" "\0"
  /*  5608 */ "GridLine" "\0"
  /*  5617 */ "GridLines" "\0"
  /*  5627 */ "GridTrack" "\0"
  /*  5637 */ "GridTracks" "\0"
  /*  5648 */ "HTMLAllCollection" "\0"
  /*  5666 */ "HTMLAnchorElement" "\0"
  /*  5684 */ "HTMLAreaElement" "\0"
  /*  5700 */ "HTMLAudioElement" "\0"
  /*  5717 */ "HTMLBRElement" "\0"
  /*  5731 */ "HTMLBaseElement" "\0"
  /*  5747 */ "HTMLBodyElement" "\0"
  /*  5763 */ "HTMLButtonElement" "\0"
  /*  5781 */ "HTMLCanvasElement" "\0"
  /*  5799 */ "HTMLCollection" "\0"
  /*  5814 */ "HTMLDListElement" "\0"
  /*  5831 */ "HTMLDataElement" "\0"
  /*  5847 */ "HTMLDataListElement" "\0"
  /*  5867 */ "HTMLDetailsElement" "\0"
  /*  5886 */ "HTMLDialogElement" "\0"
  /*  5904 */ "HTMLDirectoryElement" "\0"
  /*  5925 */ "HTMLDivElement" "\0"
  /*  5940 */ "HTMLDocument" "\0"
  /*  5953 */ "HTMLElement" "\0"
  /*  5965 */ "HTMLEmbedElement" "\0"
  /*  5982 */ "HTMLFieldSetElement" "\0"
  /*  6002 */ "HTMLFontElement" "\0"
  /*  6018 */ "HTMLFormControlsCollection" "\0"
  /*  6045 */ "HTMLFormElement" "\0"
  /*  6061 */ "HTMLFrameElement" "\0"
  /*  6078 */ "HTMLFrameSetElement" "\0"
  /*  6098 */ "HTMLHRElement" "\0"
  /*  6112 */ "HTMLHeadElement" "\0"
  /*  6128 */ "HTMLHeadingElement" "\0"
  /*  6147 */ "HTMLHtmlElement" "\0"
  /*  6163 */ "HTMLIFrameElement" "\0"
  /*  6181 */ "HTMLImageElement" "\0"
  /*  6198 */ "HTMLInputElement" "\0"
  /*  6215 */ "HTMLLIElement" "\0"
  /*  6229 */ "HTMLLabelElement" "\0"
  /*  6246 */ "HTMLLegendElement" "\0"
  /*  6264 */ "HTMLLinkElement" "\0"
  /*  6280 */ "HTMLMapElement" "\0"
  /*  6295 */ "HTMLMarqueeElement" "\0"
  /*  6314 */ "HTMLMediaElement" "\0"
  /*  6331 */ "HTMLMenuElement" "\0"
  /*  6347 */ "HTMLMetaElement" "\0"
  /*  6363 */ "HTMLMeterElement" "\0"
  /*  6380 */ "HTMLModElement" "\0"
  /*  6395 */ "HTMLOListElement" "\0"
  /*  6412 */ "HTMLObjectElement" "\0"
  /*  6430 */ "HTMLOptGroupElement" "\0"
  /*  6450 */ "HTMLOptionElement" "\0"
  /*  6468 */ "HTMLOptionsCollection" "\0"
  /*  6490 */ "HTMLOutputElement" "\0"
  /*  6508 */ "HTMLParagraphElement" "\0"
  /*  6529 */ "HTMLParamElement" "\0"
  /*  6546 */ "HTMLPictureElement" "\0"
  /*  6565 */ "HTMLPreElement" "\0"
  /*  6580 */ "HTMLProgressElement" "\0"
  /*  6600 */ "HTMLQuoteElement" "\0"
  /*  6617 */ "HTMLScriptElement" "\0"
  /*  6635 */ "HTMLSelectElement" "\0"
  /*  6653 */ "HTMLSlotElement" "\0"
  /*  6669 */ "HTMLSourceElement" "\0"
  /*  6687 */ "HTMLSpanElement" "\0"
  /*  6703 */ "HTMLStyleElement" "\0"
  /*  6720 */ "HTMLTableCaptionElement" "\0"
  /*  6744 */ "HTMLTableCellElement" "\0"
  /*  6765 */ "HTMLTableColElement" "\0"
  /*  6785 */ "HTMLTableElement" "\0"
  /*  6802 */ "HTMLTableRowElement" "\0"
  /*  6822 */ "HTMLTableSectionElement" "\0"
  /*  6846 */ "HTMLTemplateElement" "\0"
  /*  6866 */ "HTMLTextAreaElement" "\0"
  /*  6886 */ "HTMLTimeElement" "\0"
  /*  6902 */ "HTMLTitleElement" "\0"
  /*  6919 */ "HTMLTrackElement" "\0"
  /*  6936 */ "HTMLUListElement" "\0"
  /*  6953 */ "HTMLUnknownElement" "\0"
  /*  6972 */ "HTMLVideoElement" "\0"
  /*  6989 */ "HashChangeEvent" "\0"
  /*  7005 */ "Headers" "\0"
  /*  7013 */ "Headers Iterator" "\0"
  /*  7030 */ "HeapSnapshot" "\0"
  /*  7043 */ "Highlight" "\0"
  /*  7053 */ "HighlightRegistry" "\0"
  /*  7071 */ "History" "\0"
  /*  7079 */ "IDBCursor" "\0"
  /*  7089 */ "IDBCursorWithValue" "\0"
  /*  7108 */ "IDBDatabase" "\0"
  /*  7120 */ "IDBFactory" "\0"
  /*  7131 */ "IDBIndex" "\0"
  /*  7140 */ "IDBKeyRange" "\0"
  /*  7152 */ "IDBObjectStore" "\0"
  /*  7167 */ "IDBOpenDBRequest" "\0"
  /*  7184 */ "IDBRequest" "\0"
  /*  7195 */ "IDBTransaction" "\0"
  /*  7210 */ "IDBVersionChangeEvent" "\0"
  /*  7232 */ "IIRFilterNode" "\0"
  /*  7246 */ "IOUtils" "\0"
  /*  7254 */ "IdentityCredential" "\0"
  /*  7273 */ "IdleDeadline" "\0"
  /*  7286 */ "Image" "\0"
  /*  7292 */ "ImageBitmap" "\0"
  /*  7304 */ "ImageBitmapRenderingContext" "\0"
  /*  7332 */ "ImageCapture" "\0"
  /*  7345 */ "ImageCaptureError" "\0"
  /*  7363 */ "ImageCaptureErrorEvent" "\0"
  /*  7386 */ "ImageData" "\0"
  /*  7396 */ "ImageDecoder" "\0"
  /*  7409 */ "ImageDocument" "\0"
  /*  7423 */ "ImageTrack" "\0"
  /*  7434 */ "ImageTrackList" "\0"
  /*  7449 */ "InputEvent" "\0"
  /*  7460 */ "InspectorCSSParser" "\0"
  /*  7479 */ "InspectorFontFace" "\0"
  /*  7497 */ "InspectorUtils" "\0"
  /*  7512 */ "InstallTriggerImpl" "\0"
  /*  7531 */ "IntersectionObserver" "\0"
  /*  7552 */ "IntersectionObserverEntry" "\0"
  /*  7578 */ "IntlUtils" "\0"
  /*  7588 */ "InvokeEvent" "\0"
  /*  7600 */ "JSProcessActorChild" "\0"
  /*  7620 */ "JSProcessActorParent" "\0"
  /*  7641 */ "JSWindowActorChild" "\0"
  /*  7660 */ "JSWindowActorParent" "\0"
  /*  7680 */ "KeyEvent" "\0"
  /*  7689 */ "KeyboardEvent" "\0"
  /*  7703 */ "KeyframeEffect" "\0"
  /*  7718 */ "L10nFileSource" "\0"
  /*  7733 */ "L10nOverlays" "\0"
  /*  7746 */ "L10nRegistry" "\0"
  /*  7759 */ "LargestContentfulPaint" "\0"
  /*  7782 */ "LegacyMozTCPSocket" "\0"
  /*  7801 */ "Localization" "\0"
  /*  7814 */ "Location" "\0"
  /*  7823 */ "Lock" "\0"
  /*  7828 */ "LockManager" "\0"
  /*  7840 */ "MIDIAccess" "\0"
  /*  7851 */ "MIDIConnectionEvent" "\0"
  /*  7871 */ "MIDIInput" "\0"
  /*  7881 */ "MIDIInputMap" "\0"
  /*  7894 */ "MIDIMessageEvent" "\0"
  /*  7911 */ "MIDIOutput" "\0"
  /*  7922 */ "MIDIOutputMap" "\0"
  /*  7936 */ "MIDIPort" "\0"
  /*  7945 */ "MLS" "\0"
  /*  7949 */ "MLSGroupView" "\0"
  /*  7962 */ "MOZ_debug" "\0"
  /*  7972 */ "MatchGlob" "\0"
  /*  7982 */ "MatchPattern" "\0"
  /*  7995 */ "MatchPatternSet" "\0"
  /*  8011 */ "MathMLElement" "\0"
  /*  8025 */ "MediaCapabilities" "\0"
  /*  8043 */ "MediaControlService" "\0"
  /*  8063 */ "MediaController" "\0"
  /*  8079 */ "MediaDeviceInfo" "\0"
  /*  8095 */ "MediaDevices" "\0"
  /*  8108 */ "MediaElementAudioSourceNode" "\0"
  /*  8136 */ "MediaEncryptedEvent" "\0"
  /*  8156 */ "MediaError" "\0"
  /*  8167 */ "MediaKeyError" "\0"
  /*  8181 */ "MediaKeyMessageEvent" "\0"
  /*  8202 */ "MediaKeySession" "\0"
  /*  8218 */ "MediaKeyStatusMap" "\0"
  /*  8236 */ "MediaKeyStatusMap Iterator" "\0"
  /*  8263 */ "MediaKeySystemAccess" "\0"
  /*  8284 */ "MediaKeys" "\0"
  /*  8294 */ "MediaList" "\0"
  /*  8304 */ "MediaMetadata" "\0"
  /*  8318 */ "MediaQueryList" "\0"
  /*  8333 */ "MediaQueryListEvent" "\0"
  /*  8353 */ "MediaRecorder" "\0"
  /*  8367 */ "MediaRecorderErrorEvent" "\0"
  /*  8391 */ "MediaSession" "\0"
  /*  8404 */ "MediaSource" "\0"
  /*  8416 */ "MediaStream" "\0"
  /*  8428 */ "MediaStreamAudioDestinationNode" "\0"
  /*  8460 */ "MediaStreamAudioSourceNode" "\0"
  /*  8487 */ "MediaStreamError" "\0"
  /*  8504 */ "MediaStreamEvent" "\0"
  /*  8521 */ "MediaStreamTrack" "\0"
  /*  8538 */ "MediaStreamTrackAudioSourceNode" "\0"
  /*  8570 */ "MediaStreamTrackEvent" "\0"
  /*  8592 */ "MerchantValidationEvent" "\0"
  /*  8616 */ "MessageBroadcaster" "\0"
  /*  8635 */ "MessageChannel" "\0"
  /*  8650 */ "MessageEvent" "\0"
  /*  8663 */ "MessageListenerManager" "\0"
  /*  8686 */ "MessagePort" "\0"
  /*  8698 */ "MessageSender" "\0"
  /*  8712 */ "MimeType" "\0"
  /*  8721 */ "MimeTypeArray" "\0"
  /*  8735 */ "MouseEvent" "\0"
  /*  8746 */ "MouseScrollEvent" "\0"
  /*  8763 */ "MozCanvasPrintState" "\0"
  /*  8783 */ "MozDocumentMatcher" "\0"
  /*  8802 */ "MozDocumentObserver" "\0"
  /*  8822 */ "MozQueryInterface" "\0"
  /*  8840 */ "MozSharedMap" "\0"
  /*  8853 */ "MozSharedMap Iterator" "\0"
  /*  8875 */ "MozSharedMapChangeEvent" "\0"
  /*  8899 */ "MozStorageAsyncStatementParams" "\0"
  /*  8930 */ "MozStorageStatementParams" "\0"
  /*  8956 */ "MozStorageStatementRow" "\0"
  /*  8979 */ "MozWritableSharedMap" "\0"
  /*  9000 */ "MutationEvent" "\0"
  /*  9014 */ "MutationObserver" "\0"
  /*  9031 */ "MutationRecord" "\0"
  /*  9046 */ "NamedNodeMap" "\0"
  /*  9059 */ "NavigateEvent" "\0"
  /*  9073 */ "Navigation" "\0"
  /*  9084 */ "NavigationActivation" "\0"
  /*  9105 */ "NavigationCurrentEntryChangeEvent" "\0"
  /*  9139 */ "NavigationDestination" "\0"
  /*  9161 */ "NavigationHistoryEntry" "\0"
  /*  9184 */ "NavigationPreloadManager" "\0"
  /*  9209 */ "NavigationTransition" "\0"
  /*  9230 */ "Navigator" "\0"
  /*  9240 */ "NetworkInformation" "\0"
  /*  9259 */ "Node" "\0"
  /*  9264 */ "NodeFilter" "\0"
  /*  9275 */ "NodeIterator" "\0"
  /*  9288 */ "NodeList" "\0"
  /*  9297 */ "Notification" "\0"
  /*  9310 */ "NotificationEvent" "\0"
  /*  9328 */ "NotifyPaintEvent" "\0"
  /*  9345 */ "OES_draw_buffers_indexed" "\0"
  /*  9370 */ "OES_element_index_uint" "\0"
  /*  9393 */ "OES_fbo_render_mipmap" "\0"
  /*  9415 */ "OES_standard_derivatives" "\0"
  /*  9440 */ "OES_texture_float" "\0"
  /*  9458 */ "OES_texture_float_linear" "\0"
  /*  9483 */ "OES_texture_half_float" "\0"
  /*  9506 */ "OES_texture_half_float_linear" "\0"
  /*  9536 */ "OES_vertex_array_object" "\0"
  /*  9560 */ "OVR_multiview2" "\0"
  /*  9575 */ "OfflineAudioCompletionEvent" "\0"
  /*  9603 */ "OfflineAudioContext" "\0"
  /*  9623 */ "OffscreenCanvas" "\0"
  /*  9639 */ "OffscreenCanvasRenderingContext2D" "\0"
  /*  9673 */ "Option" "\0"
  /*  9680 */ "OscillatorNode" "\0"
  /*  9695 */ "PageTransitionEvent" "\0"
  /*  9715 */ "PaintRequest" "\0"
  /*  9728 */ "PaintRequestList" "\0"
  /*  9745 */ "PaintWorkletGlobalScope" "\0"
  /*  9769 */ "PannerNode" "\0"
  /*  9780 */ "ParentProcessMessageManager" "\0"
  /*  9808 */ "Path2D" "\0"
  /*  9815 */ "PathUtils" "\0"
  /*  9825 */ "PaymentAddress" "\0"
  /*  9840 */ "PaymentMethodChangeEvent" "\0"
  /*  9865 */ "PaymentRequest" "\0"
  /*  9880 */ "PaymentRequestUpdateEvent" "\0"
  /*  9906 */ "PaymentResponse" "\0"
  /*  9922 */ "Performance" "\0"
  /*  9934 */ "PerformanceEntry" "\0"
  /*  9951 */ "PerformanceEntryEvent" "\0"
  /*  9973 */ "PerformanceEventTiming" "\0"
  /*  9996 */ "PerformanceMark" "\0"
  /* 10012 */ "PerformanceMeasure" "\0"
  /* 10031 */ "PerformanceNavigation" "\0"
  /* 10053 */ "PerformanceNavigationTiming" "\0"
  /* 10081 */ "PerformanceObserver" "\0"
  /* 10101 */ "PerformanceObserverEntryList" "\0"
  /* 10130 */ "PerformancePaintTiming" "\0"
  /* 10153 */ "PerformanceResourceTiming" "\0"
  /* 10179 */ "PerformanceServerTiming" "\0"
  /* 10203 */ "PerformanceTiming" "\0"
  /* 10221 */ "PeriodicWave" "\0"
  /* 10234 */ "PermissionStatus" "\0"
  /* 10251 */ "Permissions" "\0"
  /* 10263 */ "PlacesBookmark" "\0"
  /* 10278 */ "PlacesBookmarkAddition" "\0"
  /* 10301 */ "PlacesBookmarkChanged" "\0"
  /* 10323 */ "PlacesBookmarkGuid" "\0"
  /* 10342 */ "PlacesBookmarkKeyword" "\0"
  /* 10364 */ "PlacesBookmarkMoved" "\0"
  /* 10384 */ "PlacesBookmarkRemoved" "\0"
  /* 10406 */ "PlacesBookmarkTags" "\0"
  /* 10425 */ "PlacesBookmarkTime" "\0"
  /* 10444 */ "PlacesBookmarkTitle" "\0"
  /* 10464 */ "PlacesBookmarkUrl" "\0"
  /* 10482 */ "PlacesEvent" "\0"
  /* 10494 */ "PlacesEventCounts" "\0"
  /* 10512 */ "PlacesFavicon" "\0"
  /* 10526 */ "PlacesHistoryCleared" "\0"
  /* 10547 */ "PlacesObservers" "\0"
  /* 10563 */ "PlacesPurgeCaches" "\0"
  /* 10581 */ "PlacesRanking" "\0"
  /* 10595 */ "PlacesVisit" "\0"
  /* 10607 */ "PlacesVisitRemoved" "\0"
  /* 10626 */ "PlacesVisitTitle" "\0"
  /* 10643 */ "PlacesWeakCallbackWrapper" "\0"
  /* 10669 */ "Plugin" "\0"
  /* 10676 */ "PluginArray" "\0"
  /* 10688 */ "PluginCrashedEvent" "\0"
  /* 10707 */ "PointerEvent" "\0"
  /* 10720 */ "PopStateEvent" "\0"
  /* 10734 */ "PopupBlockedEvent" "\0"
  /* 10752 */ "PopupPositionedEvent" "\0"
  /* 10773 */ "PositionStateEvent" "\0"
  /* 10792 */ "PrecompiledScript" "\0"
  /* 10810 */ "PrivateAttribution" "\0"
  /* 10829 */ "ProcessMessageManager" "\0"
  /* 10851 */ "ProcessingInstruction" "\0"
  /* 10873 */ "ProgressEvent" "\0"
  /* 10887 */ "PromiseDebugging" "\0"
  /* 10904 */ "PromiseNativeHandler" "\0"
  /* 10925 */ "PromiseRejectionEvent" "\0"
  /* 10947 */ "PublicKeyCredential" "\0"
  /* 10967 */ "PushEvent" "\0"
  /* 10977 */ "PushManager" "\0"
  /* 10989 */ "PushManagerImpl" "\0"
  /* 11005 */ "PushMessageData" "\0"
  /* 11021 */ "PushSubscription" "\0"
  /* 11038 */ "PushSubscriptionChangeEvent" "\0"
  /* 11066 */ "PushSubscriptionOptions" "\0"
  /* 11090 */ "RadioNodeList" "\0"
  /* 11104 */ "Range" "\0"
  /* 11110 */ "ReadableByteStreamController" "\0"
  /* 11139 */ "ReadableStream" "\0"
  /* 11154 */ "ReadableStream AsyncIterator" "\0"
  /* 11183 */ "ReadableStreamBYOBReader" "\0"
  /* 11208 */ "ReadableStreamBYOBRequest" "\0"
  /* 11234 */ "ReadableStreamDefaultController" "\0"
  /* 11266 */ "ReadableStreamDefaultReader" "\0"
  /* 11294 */ "Report" "\0"
  /* 11301 */ "ReportBody" "\0"
  /* 11312 */ "ReportingObserver" "\0"
  /* 11330 */ "Request" "\0"
  /* 11338 */ "ResizeObserver" "\0"
  /* 11353 */ "ResizeObserverEntry" "\0"
  /* 11373 */ "ResizeObserverSize" "\0"
  /* 11392 */ "Response" "\0"
  /* 11401 */ "SVGAElement" "\0"
  /* 11413 */ "SVGAngle" "\0"
  /* 11422 */ "SVGAnimateElement" "\0"
  /* 11440 */ "SVGAnimateMotionElement" "\0"
  /* 11464 */ "SVGAnimateTransformElement" "\0"
  /* 11491 */ "SVGAnimatedAngle" "\0"
  /* 11508 */ "SVGAnimatedBoolean" "\0"
  /* 11527 */ "SVGAnimatedEnumeration" "\0"
  /* 11550 */ "SVGAnimatedInteger" "\0"
  /* 11569 */ "SVGAnimatedLength" "\0"
  /* 11587 */ "SVGAnimatedLengthList" "\0"
  /* 11609 */ "SVGAnimatedNumber" "\0"
  /* 11627 */ "SVGAnimatedNumberList" "\0"
  /* 11649 */ "SVGAnimatedPreserveAspectRatio" "\0"
  /* 11680 */ "SVGAnimatedRect" "\0"
  /* 11696 */ "SVGAnimatedString" "\0"
  /* 11714 */ "SVGAnimatedTransformList" "\0"
  /* 11739 */ "SVGAnimationElement" "\0"
  /* 11759 */ "SVGCircleElement" "\0"
  /* 11776 */ "SVGClipPathElement" "\0"
  /* 11795 */ "SVGComponentTransferFunctionElement" "\0"
  /* 11831 */ "SVGDefsElement" "\0"
  /* 11846 */ "SVGDescElement" "\0"
  /* 11861 */ "SVGDiscardElement" "\0"
  /* 11879 */ "SVGElement" "\0"
  /* 11890 */ "SVGEllipseElement" "\0"
  /* 11908 */ "SVGFEBlendElement" "\0"
  /* 11926 */ "SVGFEColorMatrixElement" "\0"
  /* 11950 */ "SVGFEComponentTransferElement" "\0"
  /* 11980 */ "SVGFECompositeElement" "\0"
  /* 12002 */ "SVGFEConvolveMatrixElement" "\0"
  /* 12029 */ "SVGFEDiffuseLightingElement" "\0"
  /* 12057 */ "SVGFEDisplacementMapElement" "\0"
  /* 12085 */ "SVGFEDistantLightElement" "\0"
  /* 12110 */ "SVGFEDropShadowElement" "\0"
  /* 12133 */ "SVGFEFloodElement" "\0"
  /* 12151 */ "SVGFEFuncAElement" "\0"
  /* 12169 */ "SVGFEFuncBElement" "\0"
  /* 12187 */ "SVGFEFuncGElement" "\0"
  /* 12205 */ "SVGFEFuncRElement" "\0"
  /* 12223 */ "SVGFEGaussianBlurElement" "\0"
  /* 12248 */ "SVGFEImageElement" "\0"
  /* 12266 */ "SVGFEMergeElement" "\0"
  /* 12284 */ "SVGFEMergeNodeElement" "\0"
  /* 12306 */ "SVGFEMorphologyElement" "\0"
  /* 12329 */ "SVGFEOffsetElement" "\0"
  /* 12348 */ "SVGFEPointLightElement" "\0"
  /* 12371 */ "SVGFESpecularLightingElement" "\0"
  /* 12400 */ "SVGFESpotLightElement" "\0"
  /* 12422 */ "SVGFETileElement" "\0"
  /* 12439 */ "SVGFETurbulenceElement" "\0"
  /* 12462 */ "SVGFilterElement" "\0"
  /* 12479 */ "SVGForeignObjectElement" "\0"
  /* 12503 */ "SVGGElement" "\0"
  /* 12515 */ "SVGGeometryElement" "\0"
  /* 12534 */ "SVGGradientElement" "\0"
  /* 12553 */ "SVGGraphicsElement" "\0"
  /* 12572 */ "SVGImageElement" "\0"
  /* 12588 */ "SVGLength" "\0"
  /* 12598 */ "SVGLengthList" "\0"
  /* 12612 */ "SVGLineElement" "\0"
  /* 12627 */ "SVGLinearGradientElement" "\0"
  /* 12652 */ "SVGMPathElement" "\0"
  /* 12668 */ "SVGMarkerElement" "\0"
  /* 12685 */ "SVGMaskElement" "\0"
  /* 12700 */ "SVGMatrix" "\0"
  /* 12710 */ "SVGMetadataElement" "\0"
  /* 12729 */ "SVGNumber" "\0"
  /* 12739 */ "SVGNumberList" "\0"
  /* 12753 */ "SVGPathElement" "\0"
  /* 12768 */ "SVGPathSegment" "\0"
  /* 12783 */ "SVGPatternElement" "\0"
  /* 12801 */ "SVGPoint" "\0"
  /* 12810 */ "SVGPointList" "\0"
  /* 12823 */ "SVGPolygonElement" "\0"
  /* 12841 */ "SVGPolylineElement" "\0"
  /* 12860 */ "SVGPreserveAspectRatio" "\0"
  /* 12883 */ "SVGRadialGradientElement" "\0"
  /* 12908 */ "SVGRect" "\0"
  /* 12916 */ "SVGRectElement" "\0"
  /* 12931 */ "SVGSVGElement" "\0"
  /* 12945 */ "SVGScriptElement" "\0"
  /* 12962 */ "SVGSetElement" "\0"
  /* 12976 */ "SVGStopElement" "\0"
  /* 12991 */ "SVGStringList" "\0"
  /* 13005 */ "SVGStyleElement" "\0"
  /* 13021 */ "SVGSwitchElement" "\0"
  /* 13038 */ "SVGSymbolElement" "\0"
  /* 13055 */ "SVGTSpanElement" "\0"
  /* 13071 */ "SVGTextContentElement" "\0"
  /* 13093 */ "SVGTextElement" "\0"
  /* 13108 */ "SVGTextPathElement" "\0"
  /* 13127 */ "SVGTextPositioningElement" "\0"
  /* 13153 */ "SVGTitleElement" "\0"
  /* 13169 */ "SVGTransform" "\0"
  /* 13182 */ "SVGTransformList" "\0"
  /* 13199 */ "SVGUnitTypes" "\0"
  /* 13212 */ "SVGUseElement" "\0"
  /* 13226 */ "SVGViewElement" "\0"
  /* 13241 */ "Sanitizer" "\0"
  /* 13251 */ "Scheduler" "\0"
  /* 13261 */ "Screen" "\0"
  /* 13268 */ "ScreenLuminance" "\0"
  /* 13284 */ "ScreenOrientation" "\0"
  /* 13302 */ "ScriptProcessorNode" "\0"
  /* 13322 */ "ScrollAreaEvent" "\0"
  /* 13338 */ "ScrollViewChangeEvent" "\0"
  /* 13360 */ "SecurityPolicyViolationEvent" "\0"
  /* 13389 */ "Selection" "\0"
  /* 13399 */ "ServiceWorker" "\0"
  /* 13413 */ "ServiceWorkerContainer" "\0"
  /* 13436 */ "ServiceWorkerGlobalScope" "\0"
  /* 13461 */ "ServiceWorkerRegistration" "\0"
  /* 13487 */ "SessionStoreFormData" "\0"
  /* 13508 */ "SessionStoreScrollData" "\0"
  /* 13531 */ "SessionStoreUtils" "\0"
  /* 13549 */ "ShadowRealmGlobalScope" "\0"
  /* 13572 */ "ShadowRoot" "\0"
  /* 13583 */ "SharedWorker" "\0"
  /* 13596 */ "SharedWorkerGlobalScope" "\0"
  /* 13620 */ "SimpleGestureEvent" "\0"
  /* 13639 */ "SourceBuffer" "\0"
  /* 13652 */ "SourceBufferList" "\0"
  /* 13669 */ "SpeechGrammar" "\0"
  /* 13683 */ "SpeechGrammarList" "\0"
  /* 13701 */ "SpeechRecognition" "\0"
  /* 13719 */ "SpeechRecognitionAlternative" "\0"
  /* 13748 */ "SpeechRecognitionError" "\0"
  /* 13771 */ "SpeechRecognitionEvent" "\0"
  /* 13794 */ "SpeechRecognitionResult" "\0"
  /* 13818 */ "SpeechRecognitionResultList" "\0"
  /* 13846 */ "SpeechSynthesis" "\0"
  /* 13862 */ "SpeechSynthesisErrorEvent" "\0"
  /* 13888 */ "SpeechSynthesisEvent" "\0"
  /* 13909 */ "SpeechSynthesisUtterance" "\0"
  /* 13934 */ "SpeechSynthesisVoice" "\0"
  /* 13955 */ "StaticRange" "\0"
  /* 13967 */ "StereoPannerNode" "\0"
  /* 13984 */ "Storage" "\0"
  /* 13992 */ "StorageEvent" "\0"
  /* 14005 */ "StorageManager" "\0"
  /* 14020 */ "StreamFilter" "\0"
  /* 14033 */ "StreamFilterDataEvent" "\0"
  /* 14055 */ "StructuredCloneHolder" "\0"
  /* 14077 */ "StructuredCloneTester" "\0"
  /* 14099 */ "StyleSheet" "\0"
  /* 14110 */ "StyleSheetApplicableStateChangeEvent" "\0"
  /* 14147 */ "StyleSheetList" "\0"
  /* 14162 */ "StyleSheetRemovedEvent" "\0"
  /* 14185 */ "SubmitEvent" "\0"
  /* 14197 */ "SubtleCrypto" "\0"
  /* 14210 */ "SyncMessageSender" "\0"
  /* 14228 */ "SyncReadFile" "\0"
  /* 14241 */ "TCPServerSocket" "\0"
  /* 14257 */ "TCPServerSocketEvent" "\0"
  /* 14278 */ "TCPSocket" "\0"
  /* 14288 */ "TCPSocketErrorEvent" "\0"
  /* 14308 */ "TCPSocketEvent" "\0"
  /* 14323 */ "TaskController" "\0"
  /* 14338 */ "TaskPriorityChangeEvent" "\0"
  /* 14362 */ "TaskSignal" "\0"
  /* 14373 */ "TelemetryStopwatch" "\0"
  /* 14392 */ "TestUtils" "\0"
  /* 14402 */ "TestingDeprecatedInterface" "\0"
  /* 14429 */ "Text" "\0"
  /* 14434 */ "TextClause" "\0"
  /* 14445 */ "TextDecoder" "\0"
  /* 14457 */ "TextDecoderStream" "\0"
  /* 14475 */ "TextEncoder" "\0"
  /* 14487 */ "TextEncoderStream" "\0"
  /* 14505 */ "TextEvent" "\0"
  /* 14515 */ "TextMetrics" "\0"
  /* 14527 */ "TextTrack" "\0"
  /* 14537 */ "TextTrackCue" "\0"
  /* 14550 */ "TextTrackCueList" "\0"
  /* 14567 */ "TextTrackList" "\0"
  /* 14581 */ "TimeEvent" "\0"
  /* 14591 */ "TimeRanges" "\0"
  /* 14602 */ "ToggleEvent" "\0"
  /* 14614 */ "Touch" "\0"
  /* 14620 */ "TouchEvent" "\0"
  /* 14631 */ "TouchList" "\0"
  /* 14641 */ "TrackEvent" "\0"
  /* 14652 */ "TransformStream" "\0"
  /* 14668 */ "TransformStreamDefaultController" "\0"
  /* 14701 */ "TransitionEvent" "\0"
  /* 14717 */ "TreeColumn" "\0"
  /* 14728 */ "TreeColumns" "\0"
  /* 14740 */ "TreeContentView" "\0"
  /* 14756 */ "TreeWalker" "\0"
  /* 14767 */ "TrustedHTML" "\0"
  /* 14779 */ "TrustedScript" "\0"
  /* 14793 */ "TrustedScriptURL" "\0"
  /* 14810 */ "TrustedTypePolicy" "\0"
  /* 14828 */ "TrustedTypePolicyFactory" "\0"
  /* 14853 */ "UDPMessageEvent" "\0"
  /* 14869 */ "UDPSocket" "\0"
  /* 14879 */ "UIEvent" "\0"
  /* 14887 */ "URL" "\0"
  /* 14891 */ "URLSearchParams" "\0"
  /* 14907 */ "URLSearchParams Iterator" "\0"
  /* 14932 */ "UniFFIPointer" "\0"
  /* 14946 */ "UniFFIScaffolding" "\0"
  /* 14964 */ "UserActivation" "\0"
  /* 14979 */ "UserInteraction" "\0"
  /* 14995 */ "UserProximityEvent" "\0"
  /* 15014 */ "VRDisplay" "\0"
  /* 15024 */ "VRDisplayCapabilities" "\0"
  /* 15046 */ "VRDisplayEvent" "\0"
  /* 15061 */ "VREyeParameters" "\0"
  /* 15077 */ "VRFieldOfView" "\0"
  /* 15091 */ "VRFrameData" "\0"
  /* 15103 */ "VRMockController" "\0"
  /* 15120 */ "VRMockDisplay" "\0"
  /* 15134 */ "VRPose" "\0"
  /* 15141 */ "VRServiceTest" "\0"
  /* 15155 */ "VRStageParameters" "\0"
  /* 15173 */ "VTTCue" "\0"
  /* 15180 */ "VTTRegion" "\0"
  /* 15190 */ "ValidityState" "\0"
  /* 15204 */ "VideoColorSpace" "\0"
  /* 15220 */ "VideoDecoder" "\0"
  /* 15233 */ "VideoEncoder" "\0"
  /* 15246 */ "VideoFrame" "\0"
  /* 15257 */ "VideoPlaybackQuality" "\0"
  /* 15278 */ "VideoTrack" "\0"
  /* 15289 */ "VideoTrackList" "\0"
  /* 15304 */ "ViewTransition" "\0"
  /* 15319 */ "VisualViewport" "\0"
  /* 15334 */ "WEBGL_color_buffer_float" "\0"
  /* 15359 */ "WEBGL_compressed_texture_astc" "\0"
  /* 15389 */ "WEBGL_compressed_texture_etc" "\0"
  /* 15418 */ "WEBGL_compressed_texture_etc1" "\0"
  /* 15448 */ "WEBGL_compressed_texture_pvrtc" "\0"
  /* 15479 */ "WEBGL_compressed_texture_s3tc" "\0"
  /* 15509 */ "WEBGL_compressed_texture_s3tc_srgb" "\0"
  /* 15544 */ "WEBGL_debug_renderer_info" "\0"
  /* 15570 */ "WEBGL_debug_shaders" "\0"
  /* 15590 */ "WEBGL_depth_texture" "\0"
  /* 15610 */ "WEBGL_draw_buffers" "\0"
  /* 15629 */ "WEBGL_explicit_present" "\0"
  /* 15652 */ "WEBGL_lose_context" "\0"
  /* 15671 */ "WEBGL_provoking_vertex" "\0"
  /* 15694 */ "WGSLLanguageFeatures" "\0"
  /* 15715 */ "WakeLock" "\0"
  /* 15724 */ "WakeLockSentinel" "\0"
  /* 15741 */ "WaveShaperNode" "\0"
  /* 15756 */ "WebExtensionContentScript" "\0"
  /* 15782 */ "WebExtensionPolicy" "\0"
  /* 15801 */ "WebGL2RenderingContext" "\0"
  /* 15824 */ "WebGLActiveInfo" "\0"
  /* 15840 */ "WebGLBuffer" "\0"
  /* 15852 */ "WebGLContextEvent" "\0"
  /* 15870 */ "WebGLFramebuffer" "\0"
  /* 15887 */ "WebGLProgram" "\0"
  /* 15900 */ "WebGLQuery" "\0"
  /* 15911 */ "WebGLRenderbuffer" "\0"
  /* 15929 */ "WebGLRenderingContext" "\0"
  /* 15951 */ "WebGLSampler" "\0"
  /* 15964 */ "WebGLShader" "\0"
  /* 15976 */ "WebGLShaderPrecisionFormat" "\0"
  /* 16003 */ "WebGLSync" "\0"
  /* 16013 */ "WebGLTexture" "\0"
  /* 16026 */ "WebGLTransformFeedback" "\0"
  /* 16049 */ "WebGLUniformLocation" "\0"
  /* 16070 */ "WebGLVertexArrayObject" "\0"
  /* 16093 */ "WebKitCSSMatrix" "\0"
  /* 16109 */ "WebSocket" "\0"
  /* 16119 */ "WebTransport" "\0"
  /* 16132 */ "WebTransportBidirectionalStream" "\0"
  /* 16164 */ "WebTransportDatagramDuplexStream" "\0"
  /* 16197 */ "WebTransportError" "\0"
  /* 16215 */ "WebTransportReceiveStream" "\0"
  /* 16241 */ "WebTransportSendStream" "\0"
  /* 16264 */ "WheelEvent" "\0"
  /* 16275 */ "Window" "\0"
  /* 16282 */ "WindowClient" "\0"
  /* 16295 */ "WindowContext" "\0"
  /* 16309 */ "WindowGlobalChild" "\0"
  /* 16327 */ "WindowGlobalParent" "\0"
  /* 16346 */ "WindowRoot" "\0"
  /* 16357 */ "Worker" "\0"
  /* 16364 */ "WorkerDebuggerGlobalScope" "\0"
  /* 16390 */ "WorkerGlobalScope" "\0"
  /* 16408 */ "WorkerLocation" "\0"
  /* 16423 */ "WorkerNavigator" "\0"
  /* 16439 */ "WorkerTestUtils" "\0"
  /* 16455 */ "Worklet" "\0"
  /* 16463 */ "WorkletGlobalScope" "\0"
  /* 16482 */ "WritableStream" "\0"
  /* 16497 */ "WritableStreamDefaultController" "\0"
  /* 16529 */ "WritableStreamDefaultWriter" "\0"
  /* 16557 */ "XMLDocument" "\0"
  /* 16569 */ "XMLHttpRequest" "\0"
  /* 16584 */ "XMLHttpRequestEventTarget" "\0"
  /* 16610 */ "XMLHttpRequestUpload" "\0"
  /* 16631 */ "XMLSerializer" "\0"
  /* 16645 */ "XPathEvaluator" "\0"
  /* 16660 */ "XPathExpression" "\0"
  /* 16676 */ "XPathResult" "\0"
  /* 16688 */ "XRBoundedReferenceSpace" "\0"
  /* 16712 */ "XRFrame" "\0"
  /* 16720 */ "XRInputSource" "\0"
  /* 16734 */ "XRInputSourceArray" "\0"
  /* 16753 */ "XRInputSourceEvent" "\0"
  /* 16772 */ "XRInputSourcesChangeEvent" "\0"
  /* 16798 */ "XRPose" "\0"
  /* 16805 */ "XRReferenceSpace" "\0"
  /* 16822 */ "XRReferenceSpaceEvent" "\0"
  /* 16844 */ "XRRenderState" "\0"
  /* 16858 */ "XRRigidTransform" "\0"
  /* 16875 */ "XRSession" "\0"
  /* 16885 */ "XRSessionEvent" "\0"
  /* 16900 */ "XRSpace" "\0"
  /* 16908 */ "XRSystem" "\0"
  /* 16917 */ "XRView" "\0"
  /* 16924 */ "XRViewerPose" "\0"
  /* 16937 */ "XRViewport" "\0"
  /* 16948 */ "XRWebGLLayer" "\0"
  /* 16961 */ "XSLTProcessor" "\0"
  /* 16975 */ "XULCommandEvent" "\0"
  /* 16991 */ "XULElement" "\0"
  /* 17002 */ "XULFrameElement" "\0"
  /* 17018 */ "XULMenuElement" "\0"
  /* 17033 */ "XULPopupElement" "\0"
  /* 17049 */ "XULResizerElement" "\0"
  /* 17067 */ "XULTextElement" "\0"
  /* 17082 */ "XULTreeElement" "\0"
  /* 17097 */ "console" "\0"
  /* 17105 */ "webkitSpeechGrammar" "\0"
  /* 17125 */ "webkitSpeechGrammarList" "\0"
  /* 17149 */ "webkitSpeechRecognition" "\0"
  /* 17173 */ "webkitURL"
};

}  // namespace binding_detail

// Making this enum bigger than a uint16_t has consequences on the size
// of some structs (eg. WebIDLNameTableEntry) and tables. We should try
// to avoid that.
static_assert(EnumTypeFitsWithin<BindingNamesOffset, uint16_t>::value,
              "Size increase");

} // namespace mozilla::dom

