//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/PJSOracleParent.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/dom/JSOracleParent.h"

#include "mozilla/dom/PJSValidatorParent.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace dom {


auto PJSOracleParent::ProcessingError(
        Result aCode,
        const char* aReason) -> void
{
}

auto PJSOracleParent::ShouldContinueFromReplyTimeout() -> bool
{
    return true;
}

MOZ_IMPLICIT PJSOracleParent::PJSOracleParent() :
    mozilla::ipc::IToplevelProtocol("PJSOracleParent", kProtocolId, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PJSOracleParent);
}

PJSOracleParent::~PJSOracleParent()
{
    MOZ_COUNT_DTOR(PJSOracleParent);
}

auto PJSOracleParent::ActorAlloc() -> void
{
    MOZ_RELEASE_ASSERT(XRE_IsParentProcess(), "Invalid process for `PJSOracleParent'");
    AddRef();
}

auto PJSOracleParent::ActorDealloc() -> void
{
    Release();
}

auto PJSOracleParent::ManagedPJSValidatorParent(nsTArray<PJSValidatorParent*>& aArr) const -> void
{
    mManagedPJSValidatorParent.ToArray(aArr);
}

auto PJSOracleParent::ManagedPJSValidatorParent() const -> const ManagedContainer<PJSValidatorParent>&
{
    return mManagedPJSValidatorParent;
}

auto PJSOracleParent::ManagedProtocolIds() const -> mozilla::Span<mozilla::ipc::ProtocolId const>
{
    static constexpr ::mozilla::ipc::ProtocolId sIds[] = {
        PJSValidatorMsgStart
    };
    return sIds;
}

auto PJSOracleParent::GetManagedActors(mozilla::ipc::ProtocolId aProtocol) -> UntypedManagedContainer*
{
    switch (aProtocol) {
    case PJSValidatorMsgStart:
        return (&(mManagedPJSValidatorParent));
    default:
        return nullptr;
    }
}

auto PJSOracleParent::OpenPJSValidatorEndpoint(PJSValidatorParent* aActor) -> ManagedEndpoint<PJSValidatorChild>
{
    if (!aActor) {
        NS_WARNING("Cannot bind null PJSValidatorParent actor");
        return ManagedEndpoint<PJSValidatorChild>();
    }

    if (!aActor->SetManagerAndRegister(this)) {
        NS_WARNING("Failed to bind PJSValidatorParent actor");
        return ManagedEndpoint<PJSValidatorChild>();
    }

    // Mark our actor as awaiting the other side to be bound. This will
    // be cleared when a `MANAGED_ENDPOINT_{DROPPED,BOUND}` message is
    // received.
    aActor->mAwaitingManagedEndpointBind = true;
    return ManagedEndpoint<PJSValidatorChild>(mozilla::ipc::PrivateIPDLInterface(), aActor);
}

auto PJSOracleParent::BindPJSValidatorEndpoint(
        ManagedEndpoint<PJSValidatorParent> aEndpoint,
        PJSValidatorParent* aActor) -> bool
{
    return aEndpoint.Bind(mozilla::ipc::PrivateIPDLInterface(), aActor, this);
}

auto PJSOracleParent::SendPJSValidatorConstructor(PJSValidatorParent* actor) -> PJSValidatorParent*
{
    if (!actor) {
        NS_WARNING("Cannot bind null PJSValidatorParent actor");
        return nullptr;
    }

    if (!actor->SetManagerAndRegister(this)) {
        NS_WARNING("Failed to bind PJSValidatorParent actor");
        return nullptr;
    }


    // Build our constructor message.
    UniquePtr<IPC::Message> msg__ = PJSOracle::Msg_PJSValidatorConstructor(MSG_ROUTING_CONTROL);
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), actor);
    // Sentinel = 'actor'
    ((&(writer__)))->WriteSentinel(102892058);




    // Notify the other side about the newly created actor. This can
    // fail if our manager has already been destroyed.
    //
    // NOTE: If the send call fails due to toplevel channel teardown,
    // the `IProtocol::ChannelSend` wrapper absorbs the error for us,
    // so we don't tear down actors unexpectedly.

    if (mozilla::ipc::LoggingEnabledFor("PJSOracle", mozilla::ipc::ParentSide)) {
        mozilla::ipc::LogMessageForProtocol(
            "PJSOracleParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PJSOracle::Msg_PJSValidatorConstructor", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));


    // Warn, destroy the actor, and return null if the message failed to
    // send. Otherwise, return the successfully created actor reference.
    if (!sendok__) {
        NS_WARNING("Error sending PJSValidatorParent constructor");
        actor->ActorDisconnected(FailedConstructor);

        return nullptr;
    }
    return actor;
}

auto PJSOracleParent::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    default:
        FatalError("unreached");
        return;
    }
}

auto PJSOracleParent::OnMessageReceived(const Message& msg__) -> PJSOracleParent::Result
{
    int32_t route__ = msg__.routing_id();
    if (MSG_ROUTING_CONTROL != route__) {
        IProtocol* routed__ = Lookup(route__);
        if (!routed__ || !routed__->GetLifecycleProxy()) {
            if (mozilla::ipc::LoggingEnabledFor("PJSOracle", mozilla::ipc::ParentSide)) {
                mozilla::ipc::LogMessageForProtocol(
                    "PJSOracleParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Ignored message for dead actor",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eSending);
            }
            return MsgProcessed;

        }

        RefPtr<mozilla::ipc::ActorLifecycleProxy> proxy__ =
            routed__->GetLifecycleProxy();
        return proxy__->Get()->OnMessageReceived(msg__);
    }

    switch (msg__.type()) {
    case PJSOracle::Reply_PJSValidatorConstructor__ID:
        {
            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    case SHMEM_CREATED_MESSAGE_TYPE:
        {
            if (!ShmemCreated(msg__)) {
                return MsgPayloadError;
            }
            return MsgProcessed;
        }
    case SHMEM_DESTROYED_MESSAGE_TYPE:
        {
            if (!ShmemDestroyed(msg__)) {
                return MsgPayloadError;
            }
            return MsgProcessed;
        }
    }
}

auto PJSOracleParent::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PJSOracleParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}



} // namespace dom
} // namespace mozilla
namespace IPC {
auto ParamTraits<::mozilla::dom::PJSOracleParent*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    MOZ_RELEASE_ASSERT(
        aWriter->GetActor(),
        "Cannot serialize managed actors without an actor");

    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aWriter->GetActor()->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    IPC::WriteParam(aWriter, id);
}

auto ParamTraits<::mozilla::dom::PJSOracleParent*>::Read(IPC::MessageReader* aReader) -> IPC::ReadResult<paramType>
{
    MOZ_RELEASE_ASSERT(
        aReader->GetActor(),
        "Cannot deserialize managed actors without an actor");
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor = aReader->GetActor()
        ->ReadActor(aReader, true, "PJSOracle", PJSOracleMsgStart);
    if (actor.isSome()) {
        return static_cast<::mozilla::dom::PJSOracleParent*>(actor.ref());
    }
    return {};
}

} // namespace IPC
