//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PCamerasChild_h
#define PCamerasChild_h

#include "mozilla/camera/PCameras.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "TimeUnits.h"
#include "mozilla/TimeStamp.h"
#include "mozilla/ipc/BackgroundUtils.h"
#include "mozilla/media/CamerasTypes.h"
#include "nsIContentSecurityPolicy.h"

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
struct void_t;
} // namespace mozilla

namespace mozilla {
namespace camera {


class PCamerasChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class ::mozilla::ipc::PBackgroundChild;
public:
    static constexpr ::mozilla::ipc::ProtocolId kProtocolId = PCamerasMsgStart;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    typedef ::mozilla::ipc::CSPInfo CSPInfo;
    typedef ::mozilla::camera::CaptureEngine CaptureEngine;
    typedef ::mozilla::ipc::ContentPrincipalInfo ContentPrincipalInfo;
    typedef ::mozilla::ipc::ContentSecurityPolicy ContentSecurityPolicy;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::ExpandedPrincipalInfo ExpandedPrincipalInfo;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::ipc::NullPrincipalInfo NullPrincipalInfo;
    typedef ::mozilla::OriginAttributes OriginAttributes;
    typedef ::mozilla::ipc::PBackgroundChild PBackgroundChild;
    typedef ::mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef ::mozilla::dom::PContentChild PContentChild;
    typedef ::mozilla::dom::PContentParent PContentParent;
    typedef ::mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef ::nsIContentSecurityPolicy::RequireTrustedTypesForDirectiveState RequireTrustedTypesForDirectiveState;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::ipc::Shmem Shmem;
    typedef ::mozilla::ipc::SystemPrincipalInfo SystemPrincipalInfo;
    typedef ::mozilla::TimeStamp TimeStamp;
    typedef ::mozilla::media::TimeUnit TimeUnit;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::mozilla::camera::VideoCaptureCapability VideoCaptureCapability;
    typedef ::mozilla::camera::VideoFrameProperties VideoFrameProperties;
    typedef ::mozilla::ipc::WebTransportHash WebTransportHash;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;
    typedef ::mozilla::void_t void_t;

protected:
    virtual mozilla::ipc::IPCResult
    RecvCaptureEnded(const int& streamId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDeliverFrame(
            const int& streamId,
            Shmem&& buffer,
            const VideoFrameProperties& props) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDeviceChange() = 0;
    virtual mozilla::ipc::IPCResult
    RecvReplyNumberOfCaptureDevices(const int& deviceCount) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReplyNumberOfCapabilities(const int& capabilityCount) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReplyAllocateCapture(const int& captureId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReplyGetCaptureCapability(const VideoCaptureCapability& cap) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReplyGetCaptureDevice(
            const nsACString& device_name,
            const nsACString& device_id,
            const bool& scary,
            const bool& placeholder) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReplyFailure() = 0;
    virtual mozilla::ipc::IPCResult
    RecvReplySuccess() = 0;
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PCamerasChild();

    virtual ~PCamerasChild();

protected:
    void
    ActorAlloc() final;
    void
    ActorDealloc() final;
public:
    ::base::ProcessId
    OtherPid() const;
    ::GeckoChildID
    OtherChildID() const;
    ::mozilla::ipc::EndpointProcInfo
    OtherEndpointProcInfo() const;

    PBackgroundChild*
    Manager() const;

    mozilla::Span<mozilla::ipc::ProtocolId const>
    ManagedProtocolIds() const final;

    UntypedManagedContainer*
    GetManagedActors(mozilla::ipc::ProtocolId aProtocol) final;

    bool
    SendNumberOfCaptureDevices(const CaptureEngine& engine);

    bool
    SendNumberOfCapabilities(
            const CaptureEngine& engine,
            const nsACString& deviceUniqueIdUTF8);

    bool
    SendGetCaptureCapability(
            const CaptureEngine& engine,
            const nsACString& unique_idUTF8,
            const int& capability_number);

    bool
    SendGetCaptureDevice(
            const CaptureEngine& engine,
            const int& deviceIndex);

    bool
    SendAllocateCapture(
            const CaptureEngine& engine,
            const nsACString& unique_idUTF8,
            const uint64_t& windowID);

    bool
    SendReleaseCapture(
            const CaptureEngine& engine,
            const int& captureId);

    bool
    SendStartCapture(
            const CaptureEngine& engine,
            const int& captureId,
            const VideoCaptureCapability& capability);

    bool
    SendFocusOnSelectedSource(
            const CaptureEngine& engine,
            const int& captureId);

    bool
    SendStopCapture(
            const CaptureEngine& engine,
            const int& captureId);

    bool
    SendReleaseFrame(Shmem&& s);

    bool
    SendEnsureInitialized(const CaptureEngine& engine);

    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

private:
    bool mAwaitingManagedEndpointBind = false;

};


} // namespace camera
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::camera::PCamerasChild*>
{
    typedef ::mozilla::camera::PCamerasChild* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PCamerasChild_h
