//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBackgroundStorageChild_h
#define PBackgroundStorageChild_h

#include "mozilla/dom/PBackgroundStorage.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "mozilla/OriginAttributes.h"

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {


class PBackgroundStorageChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class ::mozilla::ipc::PBackgroundChild;
public:
    static constexpr ::mozilla::ipc::ProtocolId kProtocolId = PBackgroundStorageMsgStart;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::OriginAttributesPattern OriginAttributesPattern;
    typedef ::mozilla::ipc::PBackgroundChild PBackgroundChild;
    typedef ::mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::ipc::Shmem Shmem;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
    virtual mozilla::ipc::IPCResult
    RecvObserve(
            const nsACString& topic,
            const nsAString& originAttributesPattern,
            const nsACString& originScope) = 0;
    virtual mozilla::ipc::IPCResult
    RecvOriginsHavingData(nsTArray<nsCString>&& origins) = 0;
    virtual mozilla::ipc::IPCResult
    RecvLoadItem(
            const nsACString& originSuffix,
            const nsACString& originNoSuffix,
            const nsAString& key,
            const nsAString& value) = 0;
    virtual mozilla::ipc::IPCResult
    RecvLoadDone(
            const nsACString& originSuffix,
            const nsACString& originNoSuffix,
            const nsresult& rv) = 0;
    virtual mozilla::ipc::IPCResult
    RecvLoadUsage(
            const nsACString& scope,
            const int64_t& usage) = 0;
    virtual mozilla::ipc::IPCResult
    RecvError(const nsresult& rv) = 0;
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PBackgroundStorageChild();

    virtual ~PBackgroundStorageChild();

protected:
    void
    ActorAlloc() final;
    void
    ActorDealloc() final;
public:
    ::base::ProcessId
    OtherPid() const;
    ::GeckoChildID
    OtherChildID() const;
    ::mozilla::ipc::EndpointProcInfo
    OtherEndpointProcInfo() const;

    PBackgroundChild*
    Manager() const;

    mozilla::Span<mozilla::ipc::ProtocolId const>
    ManagedProtocolIds() const final;

    UntypedManagedContainer*
    GetManagedActors(mozilla::ipc::ProtocolId aProtocol) final;

    bool
    SendDeleteMe();

    bool
    SendPreload(
            const nsACString& originSuffix,
            const nsACString& originNoSuffix,
            const uint32_t& alreadyLoadedCount,
            nsTArray<nsString>* keys,
            nsTArray<nsString>* values,
            nsresult* rv);

    bool
    SendAsyncPreload(
            const nsACString& originSuffix,
            const nsACString& originNoSuffix,
            const bool& priority);

    bool
    SendAsyncGetUsage(const nsACString& scope);

    bool
    SendAsyncAddItem(
            const nsACString& originSuffix,
            const nsACString& originNoSuffix,
            const nsAString& key,
            const nsAString& value);

    bool
    SendAsyncUpdateItem(
            const nsACString& originSuffix,
            const nsACString& originNoSuffix,
            const nsAString& key,
            const nsAString& value);

    bool
    SendAsyncRemoveItem(
            const nsACString& originSuffix,
            const nsACString& originNoSuffix,
            const nsAString& key);

    bool
    SendAsyncClear(
            const nsACString& originSuffix,
            const nsACString& originNoSuffix);

    bool
    SendAsyncFlush();

    bool
    SendStartup();

    bool
    SendClearAll();

    bool
    SendClearMatchingOrigin(const nsACString& originNoSuffix);

    bool
    SendClearMatchingOriginAttributes(const OriginAttributesPattern& pattern);

    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

private:
    bool mAwaitingManagedEndpointBind = false;

};


} // namespace dom
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::dom::PBackgroundStorageChild*>
{
    typedef ::mozilla::dom::PBackgroundStorageChild* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PBackgroundStorageChild_h
