//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PMLSTransaction_h
#define PMLSTransaction_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "nsTHashtable.h"
#include "mozilla/MozPromise.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/ipc/ByteBuf.h"
#include "mozilla/ipc/FileDescriptor.h"
#include "mozilla/ipc/IPCForwards.h"
#include "mozilla/ipc/Shmem.h"

// Headers for typedefs
#include "mozilla/ipc/IPDLStructMember.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RawBytes|
//
namespace mozilla {
namespace dom {
class RawBytes final
{
private:
    typedef ::uint8_t uint8_t;

public:
#ifdef __clang__
#  pragma clang diagnostic push
#  if __has_warning("-Wdefaulted-function-deleted")
#    pragma clang diagnostic ignored "-Wdefaulted-function-deleted"
#  endif
#endif
    RawBytes() = default;
#ifdef __clang__
#  pragma clang diagnostic pop
#endif

    MOZ_IMPLICIT RawBytes(const nsTArray<uint8_t>& _data) :
        data_(_data)
    {
    }

    MOZ_IMPLICIT RawBytes(nsTArray<uint8_t>&& _data) :
        data_(std::move(_data))
    {
    }

    nsTArray<uint8_t>&
    data()
    {
        return data_;
    }
    const nsTArray<uint8_t>&
    data() const
    {
        return data_;
    }

private:
    ::mozilla::ipc::IPDLStructMember<CopyableTArray<uint8_t>> data_;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <::mozilla::dom::RawBytes>
{
    typedef ::mozilla::dom::RawBytes paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

namespace mozilla {
namespace dom {
class PMLSTransactionParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PMLSTransactionChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PMLSTransactionChild and PMLSTransactionParent
//
namespace mozilla {
namespace dom {
namespace PMLSTransaction {

nsresult
CreateEndpoints(
        mozilla::ipc::EndpointProcInfo aParentDestInfo,
        mozilla::ipc::EndpointProcInfo aChildDestInfo,
        mozilla::ipc::Endpoint<::mozilla::dom::PMLSTransactionParent>* aParent,
        mozilla::ipc::Endpoint<::mozilla::dom::PMLSTransactionChild>* aChild);

nsresult
CreateEndpoints(
        mozilla::ipc::Endpoint<::mozilla::dom::PMLSTransactionParent>* aParent,
        mozilla::ipc::Endpoint<::mozilla::dom::PMLSTransactionChild>* aChild);

enum MessageType {
    PMLSTransactionStart = PMLSTransactionMsgStart << 16,
    Msg_RequestStateDelete__ID,
    Reply_RequestStateDelete__ID,
    Msg_RequestGroupStateDelete__ID,
    Reply_RequestGroupStateDelete__ID,
    Msg_RequestGenerateIdentityKeypair__ID,
    Reply_RequestGenerateIdentityKeypair__ID,
    Msg_RequestGenerateCredentialBasic__ID,
    Reply_RequestGenerateCredentialBasic__ID,
    Msg_RequestGenerateKeyPackage__ID,
    Reply_RequestGenerateKeyPackage__ID,
    Msg_RequestGroupCreate__ID,
    Reply_RequestGroupCreate__ID,
    Msg_RequestGroupJoin__ID,
    Reply_RequestGroupJoin__ID,
    Msg_RequestGroupAdd__ID,
    Reply_RequestGroupAdd__ID,
    Msg_RequestGroupProposeAdd__ID,
    Reply_RequestGroupProposeAdd__ID,
    Msg_RequestGroupRemove__ID,
    Reply_RequestGroupRemove__ID,
    Msg_RequestGroupProposeRemove__ID,
    Reply_RequestGroupProposeRemove__ID,
    Msg_RequestGroupClose__ID,
    Reply_RequestGroupClose__ID,
    Msg_RequestGroupDetails__ID,
    Reply_RequestGroupDetails__ID,
    Msg_RequestReceive__ID,
    Reply_RequestReceive__ID,
    Msg_RequestApplyPendingCommit__ID,
    Reply_RequestApplyPendingCommit__ID,
    Msg_RequestSend__ID,
    Reply_RequestSend__ID,
    Msg_RequestExportSecret__ID,
    Reply_RequestExportSecret__ID,
    Msg_RequestGetGroupIdentifier__ID,
    Reply_RequestGetGroupIdentifier__ID,
    PMLSTransactionEnd
};

mozilla::UniquePtr<IPC::Message>
Msg_RequestStateDelete(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestStateDelete(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestGroupStateDelete(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestGroupStateDelete(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestGenerateIdentityKeypair(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestGenerateIdentityKeypair(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestGenerateCredentialBasic(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestGenerateCredentialBasic(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestGenerateKeyPackage(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestGenerateKeyPackage(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestGroupCreate(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestGroupCreate(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestGroupJoin(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestGroupJoin(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestGroupAdd(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestGroupAdd(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestGroupProposeAdd(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestGroupProposeAdd(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestGroupRemove(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestGroupRemove(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestGroupProposeRemove(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestGroupProposeRemove(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestGroupClose(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestGroupClose(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestGroupDetails(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestGroupDetails(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestReceive(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestReceive(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestApplyPendingCommit(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestApplyPendingCommit(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestSend(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestSend(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestExportSecret(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestExportSecret(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RequestGetGroupIdentifier(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_RequestGetGroupIdentifier(int32_t routingId);



} // namespace PMLSTransaction
} // namespace dom
} // namespace mozilla

#endif // ifndef PMLSTransaction_h
