//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebAuthnTransactionChild_h
#define PWebAuthnTransactionChild_h

#include "mozilla/dom/PWebAuthnTransaction.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "mozilla/dom/BrowsingContext.h"

namespace mozilla {
namespace dom {
class PWindowGlobalChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PWindowGlobalParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PWindowGlobalChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {


class PWebAuthnTransactionChild :
    public mozilla::ipc::IRefCountedProtocol
{
private:
    friend class ::mozilla::dom::PWindowGlobalChild;
public:
    static constexpr ::mozilla::ipc::ProtocolId kProtocolId = PWebAuthnTransactionMsgStart;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    typedef ::mozilla::dom::CoseAlg CoseAlg;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::dom::MaybeDiscardedBrowsingContext MaybeDiscardedBrowsingContext;
    typedef ::mozilla::dom::PWindowGlobalChild PWindowGlobalChild;
    typedef ::mozilla::dom::PWindowGlobalParent PWindowGlobalParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::ipc::Shmem Shmem;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::mozilla::dom::WebAuthnAuthenticatorSelection WebAuthnAuthenticatorSelection;
    typedef ::mozilla::dom::WebAuthnExtension WebAuthnExtension;
    typedef ::mozilla::dom::WebAuthnExtensionCredProps WebAuthnExtensionCredProps;
    typedef ::mozilla::dom::WebAuthnExtensionHmacSecret WebAuthnExtensionHmacSecret;
    typedef ::mozilla::dom::WebAuthnExtensionMinPinLength WebAuthnExtensionMinPinLength;
    typedef ::mozilla::dom::WebAuthnExtensionPrf WebAuthnExtensionPrf;
    typedef ::mozilla::dom::WebAuthnExtensionPrfEvalByCredentialEntry WebAuthnExtensionPrfEvalByCredentialEntry;
    typedef ::mozilla::dom::WebAuthnExtensionPrfValues WebAuthnExtensionPrfValues;
    typedef ::mozilla::dom::WebAuthnExtensionResult WebAuthnExtensionResult;
    typedef ::mozilla::dom::WebAuthnExtensionResultAppId WebAuthnExtensionResultAppId;
    typedef ::mozilla::dom::WebAuthnExtensionResultCredProps WebAuthnExtensionResultCredProps;
    typedef ::mozilla::dom::WebAuthnExtensionResultHmacSecret WebAuthnExtensionResultHmacSecret;
    typedef ::mozilla::dom::WebAuthnExtensionResultPrf WebAuthnExtensionResultPrf;
    typedef ::mozilla::dom::WebAuthnGetAssertionInfo WebAuthnGetAssertionInfo;
    typedef ::mozilla::dom::WebAuthnGetAssertionResponse WebAuthnGetAssertionResponse;
    typedef ::mozilla::dom::WebAuthnGetAssertionResult WebAuthnGetAssertionResult;
    typedef ::mozilla::dom::WebAuthnMakeCredentialInfo WebAuthnMakeCredentialInfo;
    typedef ::mozilla::dom::WebAuthnMakeCredentialResponse WebAuthnMakeCredentialResponse;
    typedef ::mozilla::dom::WebAuthnMakeCredentialResult WebAuthnMakeCredentialResult;
    typedef ::mozilla::dom::WebAuthnMakeCredentialRpInfo WebAuthnMakeCredentialRpInfo;
    typedef ::mozilla::dom::WebAuthnMakeCredentialUserInfo WebAuthnMakeCredentialUserInfo;
    typedef ::mozilla::dom::WebAuthnScopedCredential WebAuthnScopedCredential;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;

public:
    typedef MozPromise<WebAuthnMakeCredentialResponse, ResponseRejectReason, true> RequestRegisterPromise;
    typedef MozPromise<WebAuthnGetAssertionResponse, ResponseRejectReason, true> RequestSignPromise;
    typedef MozPromise<bool, ResponseRejectReason, true> RequestIsUVPAAPromise;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PWebAuthnTransactionChild();

    virtual ~PWebAuthnTransactionChild();

protected:
    void
    ActorAlloc() final;
    void
    ActorDealloc() final;
public:
    PWindowGlobalChild*
    Manager() const;

    mozilla::Span<mozilla::ipc::ProtocolId const>
    ManagedProtocolIds() const final;

    UntypedManagedContainer*
    GetManagedActors(mozilla::ipc::ProtocolId aProtocol) final;

    void
    RejectPendingResponses(ResponseRejectReason aReason) final;

    void
    SendRequestRegister(
            const WebAuthnMakeCredentialInfo& aTransactionInfo,
            mozilla::ipc::ResolveCallback<WebAuthnMakeCredentialResponse>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<RequestRegisterPromise>
    SendRequestRegister(const WebAuthnMakeCredentialInfo& aTransactionInfo);

    void
    SendRequestSign(
            const WebAuthnGetAssertionInfo& aTransactionInfo,
            mozilla::ipc::ResolveCallback<WebAuthnGetAssertionResponse>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<RequestSignPromise>
    SendRequestSign(const WebAuthnGetAssertionInfo& aTransactionInfo);

    void
    SendRequestIsUVPAA(
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<RequestIsUVPAAPromise>
    SendRequestIsUVPAA();

    bool
    SendRequestCancel();

    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

private:
    mozilla::ipc::IPDLAsyncReturnsCallbacks mAsyncCallbacks;

    bool mAwaitingManagedEndpointBind = false;

};


} // namespace dom
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::dom::PWebAuthnTransactionChild*>
{
    typedef ::mozilla::dom::PWebAuthnTransactionChild* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PWebAuthnTransactionChild_h
